F1<-function(data, varY,  varX, textlabel=NULL,
label=NULL, reg=FALSE, model="Linear", outliers=FALSE, quant1=0.05,
quant2 = 0.95,  ci=TRUE, level=0.95, ResetPAR=TRUE, PAR=NULL, XLAB=NULL, YLAB=NULL,
COLOR="black", COLORR="red", PCH=16, lty=1, ltyci=2,  lwd=2.5, R2.pos="topleft",
PLOT=NULL, LEGEND=NULL, AXIS=NULL, MTEXT= NULL, TEXT=NULL,
dec=",", file="Output.txt"){


###############################################
#Seccion que realiza el procedimiento
###############################################

datos<-data

if (missing(textlabel)) textlabel=NULL else textlabel=textlabel
if (missing(label)) label=NULL else label=label

datosT<-data.frame(subset(datos, select=varY), subset(datos, select=varX))

if(!is.null(textlabel)){
datosT<-data.frame(subset(datos, select=varY), subset(datos, select=varX), subset(datos, select=textlabel))
}

datos<-na.exclude(datosT)



remove_outliers <- function(x, na.rm = TRUE, ...) {
  qnt <- quantile(x, probs=c(quant1, quant2), na.rm = na.rm, ...)
  H <- 1.5 * IQR(x, na.rm = na.rm)
  y <- x
  y[x < (qnt[1] - H)] <- NA
  y[x > (qnt[2] + H)] <- NA
  y
}

if(ResetPAR==TRUE){
#Resetear par() a las opciones por defecto
resetPar <- function() {
    dev.new()
    op <- par(no.readonly = TRUE)
    dev.off()
    op
}
par(resetPar()) }
else{
}


if(!is.null(XLAB)) xlab<-XLAB else xlab<-varX
if(!is.null(YLAB)) ylab<-YLAB else ylab<-varY

if(!is.null(PAR)){
parexe<-paste("par(new,",toString(x=PAR), ")")
eval(parse(text=parexe))
}
else{
par(font.lab=2, mar=c(5,5,3,2),cex.lab=1.5)
}




ymax<-max(datos[,varY],na.rm=T)
ymin<-min(datos[,varY],na.rm=T)
xmax<-max(datos[,varX],na.rm=T)
xmin<-min(datos[,varX],na.rm=T)


if(!is.null(PLOT)){
plotexe<-paste("plot.default(","datos[,varY]~datos[,varX],",toString(x=PLOT), ")")
eval(parse(text=plotexe))
}
else{
plotexe<-paste("plot.default(","datos[,varY]~datos[,varX],",
"xlab=xlab,", "ylab=ylab,","col=COLOR,","pch=PCH",")")
eval(parse(text=plotexe))
}


if(reg==TRUE){

if(model=="Linear"){

datos2<-data.frame(datos[,varY],datos[,varX])
colnames(datos2)<-c(varY,varX)
fo<-paste(names(datos2)[1], "~", names(datos2)[2])
reg<-lm(fo,data=datos2)
res<-residuals(reg)

if(outliers==TRUE){
resOut<- remove_outliers(res)
datosOut<-data.frame(datos,resOut)
datos<-na.exclude(datosOut)
datos2<-data.frame(datos[,varY],datos[,varX])
colnames(datos2)<-c(varY,varX)
fo<-paste(names(datos2)[1], "~", names(datos2)[2])
reg<-lm(fo,data=datos2)
}

Re<-summary(reg)



cx<-seq(xmin,xmax, length.out = 100)
cy<-reg$coefficients[1]+reg$coefficients[2]*cx

lines(cx,cy,  col=COLORR, lty=lty, lwd=lwd)

res<-residuals(reg)

if(ci==TRUE){
xx<-datos2[,2]
yy<-datos2[,1]
reg11<-lm(yy~xx)
prd<-predict(reg11,newdata=data.frame(xx=cx), interval = c("confidence"), level = level,type="response")
lines(cx,prd[,2],col=COLORR,lty=ltyci)
lines(cx,prd[,3],col=COLORR,lty=ltyci)
}

#Normality
residshapiro<-length(res)
if(5 < residshapiro & residshapiro <5000){
Lillie<-nortest::lillie.test(res)
}
else{
Lillie<-"It was not possible to perform the Lilliefors test for normality test, n must be between 5 and 5000"
}

#Autocorrelation
DW<-lmtest::dwtest(reg)

#Homocedasticity
BreuschPagan<-lmtest::bptest(reg)


Resultados<-list("LINEAR REGRESSION",Re,"Normality", Lillie, "Autocorrelation", DW, "Homocedasticity",BreuschPagan)

print(Resultados)

if(!is.null(file)){
sink(file)
print(Resultados)
sink()
}
if(!is.null(R2.pos)){
legend(x=R2.pos, legend=bquote(italic(r)^2 == .(format(Re$r.squared, digits = 2, decimal.mark=dec))), bty="n", cex=1.4)
}
}#Fin Linear



if(model=="Log"){

if(min(datos[,varX])>=0.01){
datos2<-data.frame(datos[,varY],log(datos[,varX]))
colnames(datos2)<-c(varY,varX)
fo<-paste(names(datos2)[1], "~", names(datos2)[2])
reg<-lm(fo,data=datos2)
res<-residuals(reg)

if(outliers==TRUE){
resOut<- remove_outliers(res)
datosOut<-data.frame(datos,resOut)
datos<-na.exclude(datosOut)

datos2<-data.frame(datos[,varY],log(datos[,varX]))
colnames(datos2)<-c(varY,varX)
fo<-paste(names(datos2)[1], "~", names(datos2)[2])
reg<-lm(fo,data=datos2)
}

Re<-summary(reg)



cx<-seq(xmin,xmax, length.out = 100)
cy<-reg$coefficients[1]+reg$coefficients[2]*log(cx)

lines(cx,cy,  col=COLORR, lty=lty, lwd=lwd)

res<-residuals(reg)

#Normality
residshapiro<-length(res)
if(5 < residshapiro & residshapiro <5000){
Lillie<-nortest::lillie.test(res)
}
else{
Lillie<-"It was not possible to perform the Lilliefors test for normality test, n must be between 5 and 5000"
}

#Autocorrelation
DW<-lmtest::dwtest(reg)

#Homocedasticity
BreuschPagan<-lmtest::bptest(reg)


Resultados<-list("LOG REGRESSION",Re,"Normality", Lillie, "Autocorrelation", DW, "Homocedasticity",BreuschPagan)

print(Resultados)

if(!is.null(file)){
sink(file)
print(Resultados)
sink()
}

if(!is.null(R2.pos)){
legend(x=R2.pos, legend=bquote(italic(r)^2 == .(format(Re$r.squared, digits = 2, decimal.mark=dec))), bty="n", cex=1.4)
}
}#Fin si el valor de X es mayor de cero
}#Fin Log


if(model=="S-curve"){

if(min(datos[,varY])>=0.01){
datos2<-data.frame(log(datos[,varY]),1/datos[,varX])
colnames(datos2)<-c(varY,varX)
fo<-paste(names(datos2)[1], "~", names(datos2)[2])
reg<-lm(fo,data=datos2)
res<-datos[,varY]-exp(reg$coefficients[1]+reg$coefficients[2]/datos[,varX])


if(outliers==TRUE){
resOut<- remove_outliers(res)
datosOut<-data.frame(datos,resOut)
datos<-na.exclude(datosOut)

datos2<-data.frame(log(datos[,varY]),1/datos[,varX])
colnames(datos2)<-c(varY,varX)
fo<-paste(names(datos2)[1], "~", names(datos2)[2])
reg<-lm(fo,data=datos2)
}

Re<-summary(reg)


cx<-seq(xmin,xmax, length.out = 100)
cy<-exp(reg$coefficients[1]+reg$coefficients[2]/cx)

lines(cx,cy,  col=COLORR, lty=lty, lwd=lwd)

res<-residuals(reg)

#Normality
residshapiro<-length(res)
if(5 < residshapiro & residshapiro <5000){
Lillie<-nortest::lillie.test(res)
}
else{
Lillie<-"It was not possible to perform the Lilliefors test for normality test, n must be between 5 and 5000"
}

#Autocorrelation
DW<-lmtest::dwtest(reg)

#Homocedasticity
BreuschPagan<-lmtest::bptest(reg)


Resultados<-list("S-CURVE REGRESSION",Re,"Normality", Lillie, "Autocorrelation", DW, "Homocedasticity",BreuschPagan)

print(Resultados)

if(!is.null(file)){
sink(file)
print(Resultados)
sink()
}

if(!is.null(R2.pos)){
legend(x=R2.pos, legend=bquote(italic(r)^2 == .(format(Re$r.squared, digits = 2, decimal.mark=dec))), bty="n", cex=1.4)
}
}#Fin si el valor de X es mayor de cero
}#Fin S-curve


if(model=="Power"){

if(min(datos[,varY])>=0.01){
if(min(datos[,varX])>=0.01){
datos2<-data.frame(log(datos[,varY]),log(datos[,varX]))
colnames(datos2)<-c(varY,varX)
fo<-paste(names(datos2)[1], "~", names(datos2)[2])
reg<-lm(fo,data=datos2)
res<-datos[,varY]-exp(reg$coefficients[1])*datos[,varX]^reg$coefficients[2]

if(outliers==TRUE){
resOut<- remove_outliers(res)
datosOut<-data.frame(datos,resOut)
datos<-na.exclude(datosOut)

datos2<-data.frame(log(datos[,varY]),log(datos[,varX]))
colnames(datos2)<-c(varY,varX)
fo<-paste(names(datos2)[1], "~", names(datos2)[2])
reg<-lm(fo,data=datos2)
}

Re<-summary(reg)



cx<-seq(xmin,xmax, length.out = 100)
cy<-exp(reg$coefficients[1])*cx^reg$coefficients[2]

lines(cx,cy,  col=COLORR, lty=lty, lwd=lwd)

res<-residuals(reg)

#Normality
residshapiro<-length(res)
if(5 < residshapiro & residshapiro <5000){
Lillie<-nortest::lillie.test(res)
}
else{
Lillie<-"It was not possible to perform the Lilliefors test for normality test, n must be between 5 and 5000"
}

#Autocorrelation
DW<-lmtest::dwtest(reg)

#Homocedasticity
BreuschPagan<-lmtest::bptest(reg)


Resultados<-list("POWER REGRESSION",Re,"Normality", Lillie, "Autocorrelation", DW, "Homocedasticity",BreuschPagan)

print(Resultados)

if(!is.null(file)){
sink(file)
print(Resultados)
sink()
}
if(!is.null(R2.pos)){
legend(x=R2.pos, legend=bquote(italic(r)^2 == .(format(Re$r.squared, digits = 2, decimal.mark=dec))), bty="n", cex=1.4)
}
}#mini Y
}#min X
}#Fin Power


if(model=="Exp"){

if(min(datos[,varY])>=0.01){
datos2<-data.frame(log(datos[,varY]),datos[,varX])
colnames(datos2)<-c(varY,varX)
fo<-paste(names(datos2)[1], "~", names(datos2)[2])
reg<-lm(fo,data=datos2)
res<-datos[,varY]-exp(reg$coefficients[1])*exp(datos[,varX]*reg$coefficients[2])


if(outliers==TRUE){
resOut<- remove_outliers(res)
datosOut<-data.frame(datos,resOut)
datos<-na.exclude(datosOut)

datos2<-data.frame(log(datos[,varY]),datos[,varX])
colnames(datos2)<-c(varY,varX)
fo<-paste(names(datos2)[1], "~", names(datos2)[2])
reg<-lm(fo,data=datos2)
}

Re<-summary(reg)


cx<-seq(xmin,xmax, length.out = 100)
cy<-exp(reg$coefficients[1])*exp(cx*reg$coefficients[2])

lines(cx,cy,  col=COLORR, lty=lty, lwd=lwd)

res<-residuals(reg)

#Normality

residshapiro<-length(res)
if(5 < residshapiro & residshapiro <5000){
Lillie<-nortest::lillie.test(res)
}
else{
Lillie<-"It was not possible to perform the Lilliefors test for normality test, n must be between 5 and 5000"
}

#Autocorrelation
DW<-lmtest::dwtest(reg)

#Homocedasticity
BreuschPagan<-lmtest::bptest(reg)


Resultados<-list("EXPONENTIAL REGRESSION",Re,"Normality", Lillie, "Autocorrelation", DW, "Homocedasticity",BreuschPagan)

print(Resultados)

if(!is.null(file)){
sink(file)
print(Resultados)
sink()
}
if(!is.null(R2.pos)){
legend(x=R2.pos, legend=bquote(italic(r)^2 == .(format(Re$r.squared, digits = 2, decimal.mark=dec))), bty="n", cex=1.4)
}
}#Fin si el valor de X es mayor de cero
}#Fin Exp


if(model=="Quadratic"){

datos2<-data.frame(datos[,varY],datos[,varX],datos[,varX]^2)
colnames(datos2)<-c(varY,varX,paste(varX,"2",sep=""))
fo<-paste(names(datos2)[1], "~", names(datos2)[2],"+",names(datos2)[3])
reg<-lm(fo,data=datos2)
res<-residuals(reg)

if(outliers==TRUE){
resOut<- remove_outliers(res)
datosOut<-data.frame(datos,resOut)
datos<-na.exclude(datosOut)

datos2<-data.frame(datos[,varY],datos[,varX],datos[,varX]^2)
colnames(datos2)<-c(varY,varX,paste(varX,"2",sep=""))
fo<-paste(names(datos2)[1], "~", names(datos2)[2],"+",names(datos2)[3])
reg<-lm(fo,data=datos2)
}

Re<-summary(reg)



cx<-seq(xmin,xmax, length.out = 100)
cy<-reg$coefficients[1]+reg$coefficients[2]*cx+reg$coefficients[3]*cx^2

lines(cx,cy,  col=COLORR, lty=lty, lwd=lwd)

res<-residuals(reg)

#Normality

residshapiro<-length(res)
if(5 < residshapiro & residshapiro <5000){
Lillie<-nortest::lillie.test(res)
}
else{
Lillie<-"It was not possible to perform the Lilliefors test for normality test, n must be between 5 and 5000"
}

#Autocorrelation
DW<-lmtest::dwtest(reg)

#Homocedasticity
BreuschPagan<-lmtest::bptest(reg)


Resultados<-list("QUADRATIC REGRESSION",Re,"Normality", Lillie, "Autocorrelation", DW, "Homocedasticity",BreuschPagan)

print(Resultados)

if(!is.null(file)){
sink(file)
print(Resultados)
sink()
}
if(!is.null(R2.pos)){
legend(x=R2.pos, legend=bquote(italic(r)^2 == .(format(Re$r.squared, digits = 2, decimal.mark=dec))), bty="n", cex=1.4)
}
}#Fin Quadratic

if(model=="Cubic"){

datos2<-data.frame(datos[,varY],datos[,varX],datos[,varX]^2,datos[,varX]^3)
colnames(datos2)<-c(varY,varX,paste(varX,"2",sep=""),paste(varX,"3",sep=""))
fo<-paste(names(datos2)[1], "~", names(datos2)[2],"+",names(datos2)[3],"+",names(datos2)[4])
reg<-lm(fo,data=datos2)
res<-residuals(reg)

if(outliers==TRUE){
resOut<- remove_outliers(res)
datosOut<-data.frame(datos,resOut)
datos<-na.exclude(datosOut)

datos2<-data.frame(datos[,varY],datos[,varX],datos[,varX]^2,datos[,varX]^3)
colnames(datos2)<-c(varY,varX,paste(varX,"2",sep=""),paste(varX,"3",sep=""))
fo<-paste(names(datos2)[1], "~", names(datos2)[2],"+",names(datos2)[3],"+",names(datos2)[4])
reg<-lm(fo,data=datos2)
}

Re<-summary(reg)




cx<-seq(xmin,xmax, length.out = 100)
cy<-reg$coefficients[1]+reg$coefficients[2]*cx+reg$coefficients[3]*cx^2+reg$coefficients[4]*cx^3

lines(cx,cy,  col=COLORR, lty=lty, lwd=lwd)

res<-residuals(reg)

#Normality

residshapiro<-length(res)
if(5 < residshapiro & residshapiro <5000){
Lillie<-nortest::lillie.test(res)
}
else{
Lillie<-"It was not possible to perform the Lilliefors test for normality test, n must be between 5 and 5000"
}

#Autocorrelation
DW<-lmtest::dwtest(reg)

#Homocedasticity
BreuschPagan<-lmtest::bptest(reg)


Resultados<-list("CUBIC REGRESSION",Re,"Normality", Lillie, "Autocorrelation", DW, "Homocedasticity",BreuschPagan)

print(Resultados)

if(!is.null(file)){
sink(file)
print(Resultados)
sink()
}
if(!is.null(R2.pos)){
legend(x=R2.pos, legend=bquote(italic(r)^2 == .(format(Re$r.squared, digits = 2, decimal.mark=dec))), bty="n", cex=1.4)
}
}#Fin Cubic



if(model=="Inverse"){

if(is.na(match(0,datos[,varX]))){
datos2<-data.frame(datos[,varY],1/datos[,varX])
colnames(datos2)<-c(varY,varX)
fo<-paste(names(datos2)[1], "~", names(datos2)[2])
reg<-lm(fo,data=datos2)
res<-residuals(reg)

if(outliers==TRUE){
resOut<- remove_outliers(res)
datosOut<-data.frame(datos,resOut)
datos<-na.exclude(datosOut)

datos2<-data.frame(datos[,varY],1/datos[,varX])
colnames(datos2)<-c(varY,varX)
fo<-paste(names(datos2)[1], "~", names(datos2)[2])
reg<-lm(fo,data=datos2)
}

Re<-summary(reg)


cx<-seq(xmin,xmax, length.out = 100)
cy<-reg$coefficients[1]+reg$coefficients[2]*1/cx

lines(cx,cy,  col=COLORR, lty=lty, lwd=lwd)

res<-residuals(reg)

#Normality

residshapiro<-length(res)
if(5 < residshapiro & residshapiro <5000){
Lillie<-nortest::lillie.test(res)
}
else{
Lillie<-"It was not possible to perform the Lilliefors test for normality test, n must be between 5 and 5000"
}

#Autocorrelation
DW<-lmtest::dwtest(reg)

#Homocedasticity
BreuschPagan<-lmtest::bptest(reg)


Resultados<-list("INVERSE REGRESSION",Re,"Normality", Lillie, "Autocorrelation", DW, "Homocedasticity",BreuschPagan)

print(Resultados)

if(!is.null(file)){
sink(file)
print(Resultados)
sink()
}
if(!is.null(R2.pos)){
legend(x=R2.pos, legend=bquote(italic(r)^2 == .(format(Re$r.squared, digits = 2, decimal.mark=dec))), bty="n", cex=1.4)
}
}#Fin si el valor de X es mayor de cero
}#Fin Inverse



}#Fin regresion








if(!is.null(textlabel)){
if(!is.null(label)){
tx<-paste("text(","x=datos[,varX],", "y=datos[,varY],", "labels=datos[,textlabel],", toString(x=label), ")")
eval(parse(text=tx))
}
else{
tx<-paste("text(","x=datos[,varX],", "y=datos[,varY],", "labels=datos[,textlabel],", "pos=4", ")")
eval(parse(text=tx))
}
}


if(!is.null(LEGEND)){
legendexe<-paste("legend(",toString(x=LEGEND), ")")
eval(parse(text=legendexe))
}
else{
}


if(!is.null(AXIS)){
axisexe<-paste("axis(",toString(x=AXIS), ")")
eval(parse(text=axisexe))
}
else{
}

if(!is.null(MTEXT)){
mtextexe<-paste("mtext(",toString(x=MTEXT), ")")
eval(parse(text=mtextexe))
}
else{
}

if(!is.null(TEXT)){
textexe<-paste("text(",toString(x=TEXT), ")")
eval(parse(text=textexe))
}
else{
}








}
