F16<-function(data, varY,  FactorX, group, label=NULL, method="mean", dev="sd",
ResetPAR=TRUE,  PAR=NULL, order=NULL, OrderCat=NULL, LabelCat=NULL,
XLAB=NULL, YLAB=NULL, XLIM=NULL, YLIM=NULL, COLOR=NULL, COLORI="black", 
PCH=NULL, CEX=1, LEGEND=NULL, AXIS=NULL,MTEXT= NULL, TEXT=NULL){


###############################################
#Seccion que realiza el procedimiento
###############################################

datos<-data

datosT<-data.frame(subset(datos, select=varY), subset(datos, select=FactorX))

if(!is.null(group)){
datosT<-data.frame(datosT, subset(datos, select=group))
}


datos<-na.exclude(datosT)


if (missing(OrderCat)) OrderCat=NULL else OrderCat=OrderCat
if (missing(LabelCat)) LabelCat=OrderCat else LabelCat=LabelCat


if(ResetPAR==TRUE){
#Resetear par() a las opciones por defecto
resetPar <- function() {
    dev.new()
    op <- par(no.readonly = TRUE)
    dev.off()
    op
}
par(resetPar()) }
else{
}


dati<-as.character(unique(datos[,group]))

datas<-datos

if(!is.null(COLOR)){

}
else{
COLOR<-rainbow(length(unique(datos[,group])))
}


catn<-length(unique(datos[,group]))


if(!is.null(PCH)){

}
else{
pch1<-14+1
for (t in 2:catn){
pcht<-14+t
pch1<-append(pch1,pcht)
}
PCH<-pch1
}


if(!is.null(XLAB)) xlab<-XLAB else xlab<-FactorX
if(!is.null(YLAB)) ylab<-YLAB else ylab<-varY

if(!is.null(PAR)){
parexe<-paste("par(new,",toString(x=PAR), ")")
eval(parse(text=parexe))
}
else{
par(font.lab=2, mar=c(5,5,3,2),cex.lab=1.5)
}


datos[,FactorX]<-factor(datos[,FactorX], levels = unique(datos[,FactorX]), labels = unique(datos[,FactorX]))


if(!is.null(method)) {
median<- tapply(datos[, varY], datos[, FactorX], method)
}
else{
median<- tapply(datos[, varY], datos[, FactorX], median)
}


if(!is.null(OrderCat)){
datos[,FactorX]<-factor(datos[,FactorX], levels = OrderCat, labels = LabelCat)
}
else{
if(!is.null(order)){
if(order=="decreasing") names<-names(sort(median, decreasing=TRUE)) else names<-names(sort(median, decreasing=FALSE))

if(order=="alphaAZ") names<-sort(names, decreasing=FALSE) else names<-names

if(order=="alphaZA") names<-sort(names, decreasing=TRUE) else names<-names


if(!is.null(LabelCat))  LabelCat<-LabelCat else LabelCat<-names
datos[,FactorX]<-factor(datos[,FactorX], levels = names, labels = LabelCat)
}
else{
if(!is.null(LabelCat)) datos[,FactorX]<-factor(datos[,FactorX], levels = unique(datos[,FactorX]), labels = LabelCat) else datos<-datos
}
}


if(!is.null(method)) {

mn.t<- aggregate(datos[, varY],list(datos[, group],datos[, FactorX]), method)
length<- aggregate(datos[, varY],list(datos[, group],datos[, FactorX]), length)
sd.t<- aggregate(datos[, varY],list(datos[, group],datos[, FactorX]), sd)

if(dev=="sd"){
sd.t <- aggregate(datos[, varY],list(datos[, group],datos[, FactorX]), sd)
}
else{
sd.t<-data.frame(sd.t[,1:2],sd.t[,3]/sqrt(length[,3]))
}

if(!is.null(XLIM)){
}
else{
max<-length(unique(datos[,FactorX]))+1

XLIM<-c(1,max)
}

if(!is.null(YLIM)){
}
else{
maxx<-max(mn.t[,3] + sd.t[,3])+1*max(mn.t[,3] + sd.t[,3])/100
minn<-min(mn.t[,3] - sd.t[,3])-1*min(mn.t[,3] - sd.t[,3])/100
YLIM<-c(minn,maxx)
}



plot.default(mn.t[, 2], mn.t[,3] ,pch=PCH, col = "transparent", xaxt="n", yaxt="n",xlab="", ylab="",
xlim=XLIM, ylim=YLIM, cex=CEX)

rb <- boxplot(datos[,varY] ~ datos[,FactorX], col = "transparent" , border = "transparent", xlab=xlab,
ylab=ylab, add=TRUE, xlim=XLIM, ylim=YLIM, axes=FALSE)

xi <- seq(rb$n)

mn.t<-data.frame(mn.t,xi)
sd.t<-data.frame(sd.t,xi)

colnames(mn.t)<-c(group,FactorX, varY, "Pos")
colnames(sd.t)<-c(group,FactorX, varY, "Pos")


if(!is.null(label)){
tx<-paste("text(","mn.t[, 2],", "mn.t[, 3],", "labels=unique(mn.t[, 2]),", toString(x=label), ")")
eval(parse(text=tx))
}
else{
tx<-paste("text(","mn.t[, 2],", "mn.t[, 3],", "labels=unique(mn.t[, 2]),", "pos=4", ")")
eval(parse(text=tx))
}

for(h in 1:catn){
datos3<-subset(mn.t,mn.t[,group]==dati[h])
datos4<-subset(sd.t,sd.t[,group]==dati[h])

arrows(datos3[,"Pos"],  datos3[,3] - datos4[,3], datos3[,"Pos"], datos3[,3] + datos4[,3], code = 3, col = COLORI, angle = 90, length = .1)

points(datos3[,FactorX], datos3[, varY], col = COLOR[h], pch = PCH[h], cex=CEX)
}
}
else{

mn.t<- aggregate(datos[, varY],list(datos[, group],datos[, FactorX]), mean)
length<- aggregate(datos[, varY],list(datos[, group],datos[, FactorX]), length)
sd.t<- aggregate(datos[, varY],list(datos[, group],datos[, FactorX]), sd)

if(dev=="sd"){
sd.t <- aggregate(datos[, varY],list(datos[, group],datos[, FactorX]), sd)
}
else{
sd.t<-data.frame(sd.t[,1:2],sd.t[,3]/sqrt(length[,3]))
}

if(!is.null(XLIM)){
}
else{
max<-length(unique(datos[,FactorX]))+1

XLIM<-c(1,max)
}

if(!is.null(YLIM)){
}
else{
maxx<-max(mn.t[,3] + sd.t[,3])+1*max(mn.t[,3] + sd.t[,3])/100
minn<-min(mn.t[,3] - sd.t[,3])-1*min(mn.t[,3] - sd.t[,3])/100
YLIM<-c(minn,maxx)
}


plot.default(datos[, FactorX], datos[,varY] ,pch=PCH, col = "transparent", xaxt="n", yaxt="n",xlab="", ylab="",
xlim=XLIM, ylim=YLIM, cex=CEX)

rb <- boxplot(datos[,varY] ~ datos[,FactorX], col = "transparent" , border = "transparent", xlab=xlab,
ylab=ylab, add=TRUE, xlim=XLIM, ylim=YLIM, axes=FALSE)


if(!is.null(label)){
tx<-paste("text(","mn.t[, 2],", "mn.t[, 3],", "labels=unique(mn.t[, 2]),", toString(x=label), ")")
eval(parse(text=tx))
}
else{
tx<-paste("text(","mn.t[, 2],", "mn.t[, 3],", "labels=unique(mn.t[, 2]),", "pos=4", ")")
eval(parse(text=tx))
}


for(h in 1:catn){
datos3<-subset(datos,datos[,group]==dati[h])
points(datos3[,FactorX], datos3[, varY], col = COLOR[h], pch = PCH[h], cex=CEX)
}
}



if(!is.null(LEGEND)){
legendexe<-paste("legend(",toString(x=LEGEND), ")")
eval(parse(text=legendexe))
}
else{
legendexe<-paste("legend(","x='topleft',","legend=dati,","bty='n',", "col=COLOR,",
"pch=PCH", ")")
eval(parse(text=legendexe))
}

if(!is.null(AXIS)){
axisexe<-paste("axis(",toString(x=AXIS), ")")
eval(parse(text=axisexe))
}
else{
}

if(!is.null(MTEXT)){
mtextexe<-paste("mtext(",toString(x=MTEXT), ")")
eval(parse(text=mtextexe))
}
else{
}

if(!is.null(TEXT)){
textexe<-paste("text(",toString(x=TEXT), ")")
eval(parse(text=textexe))
}
else{
}








}
