F22<-function(data, varY,  varX, Factor, method="mean",
dev="sd", barY=TRUE, barX=FALSE, textlabel=FALSE, label=NULL, reg=FALSE, model="Linear",
outliers=FALSE, quant1=0.05, quant2 = 0.95, ResetPAR=TRUE, PAR=NULL, XLAB=NULL, YLAB=NULL,
XLIM=NULL, YLIM=NULL,  COLOR="black", COLORI="black", COLORR="red",
PCH=16, lty=3, lwd=2.5, R2.pos="topleft", PLOT=NULL, LEGEND=NULL, AXIS=NULL,
MTEXT= NULL, TEXT=NULL, file1="Output.txt", file2="Average and error bars.csv",
na="NA", dec=",", row.names=FALSE){



###############################################
#Seccion que realiza el procedimiento
###############################################

datos<-data

if (missing(textlabel)) textlabel=FALSE else textlabel=textlabel
if (missing(label)) label=NULL else label=label

datosT<-data.frame(subset(datos, select=varY), subset(datos, select=varX), subset(datos, select=Factor))

datos<-na.exclude(datosT)



remove_outliers <- function(x, na.rm = TRUE, ...) {
  qnt <- quantile(x, probs=c(quant1, quant2), na.rm = na.rm, ...)
  H <- 1.5 * IQR(x, na.rm = na.rm)
  y <- x
  y[x < (qnt[1] - H)] <- NA
  y[x > (qnt[2] + H)] <- NA
  y
}


if(ResetPAR==TRUE){
#Resetear par() a las opciones por defecto
resetPar <- function() {
    dev.new()
    op <- par(no.readonly = TRUE)
    dev.off()
    op
}
par(resetPar()) }
else{
}


medianY<- tapply(datos[, varY], datos[, Factor], median)
medianX<- tapply(datos[, varX], datos[, Factor], median)

meanY<- tapply(datos[, varY], datos[, Factor], mean)
meanX<- tapply(datos[, varX], datos[, Factor], mean)

sdY<- tapply(datos[, varY], datos[, Factor], sd)
sdX<- tapply(datos[, varX], datos[, Factor], sd)

lengthY<-tapply(datos[, varY], datos[, Factor], length)

lengthX<-tapply(datos[, varX], datos[, Factor], length)

seY<-sdY/sqrt(lengthY)
seX<-sdX/sqrt(lengthX)

dati<-t(rbind(meanX,meanY,medianX, medianY, sdX, sdY, seX,seY))


datos2 <- data.frame(Factor=rownames(dati),dati) 



colnames(datos2)<-c(Factor, paste("mean",varX,sep=""),  paste("mean",varY,sep=""),
paste("median",varX,sep=""),  paste("median",varY,sep=""), paste("sd",varX,sep=""),
paste("sd",varY,sep=""), paste("se",varX,sep=""), paste("se",varY,sep=""))


if(!is.null(XLAB)) xlab<-XLAB else xlab<-varX
if(!is.null(YLAB)) ylab<-YLAB else ylab<-varY

if(!is.null(PAR)){
parexe<-paste("par(new,",toString(x=PAR), ")")
eval(parse(text=parexe))
}
else{
par(font.lab=2, mar=c(5,5,3,2),cex.lab=1.5)
}


if(method=="mean"){
datos3<-datos2[,1:3]
}

if(method=="median"){
datos3<-datos2[,c(1,4,5)]
}

if(dev=="sd"){
datos3<-cbind(datos3, datos2[, c(6,7)])
}

if(dev=="se"){
datos3<-cbind(datos3, datos2[, c(8,9)])
}


if(barX==TRUE){
if(!is.null(XLIM)){
}
else{
maxx<-max(datos3[,2] + datos3[,4])+1*max(datos3[,2] + datos3[,4])/100
minn<-min(datos3[,2] - datos3[,4])-1*min(datos3[,2] - datos3[,4])/100
XLIM<-c(minn,maxx)
}
}

if(barY==TRUE){
if(!is.null(YLIM)){
}
else{
maxx<-max(datos3[,3] + datos3[,5])+1*max(datos3[,3] + datos3[,5])/100
minn<-min(datos3[,3] - datos3[,5])-1*min(datos3[,3] - datos3[,5])/100
YLIM<-c(minn,maxx)
}
}



if(dec=="."){
write.csv(x=datos2,file = file2, fileEncoding = "", row.names=row.names,na=na)
}
else{
write.csv2(x = datos2,file = file2, fileEncoding = "", row.names=row.names,na=na)
}



ymax<-max(datos3[,3],na.rm=T)
ymin<-min(datos3[,3],na.rm=T)
xmax<-max(datos3[,2],na.rm=T)
xmin<-min(datos3[,2],na.rm=T)


if(!is.null(PLOT)){
plotexe<-paste("plot.default(","datos3[,3]~datos3[,2],",toString(x=PLOT), ")")
eval(parse(text=plotexe))
}
else{
plotexe<-paste("plot.default(","datos3[,3]~datos3[,2],",
"xlab=xlab,", "ylab=ylab,","col=COLOR,","pch=PCH,",
"xlim=XLIM,", "ylim=YLIM", ")")
eval(parse(text=plotexe))
}
if(barY==TRUE){
arrows(datos3[,2], datos3[,3]- datos3[,5],datos3[,2], datos3[,3] + datos3[,5], code = 3, col = COLORI, angle = 90, length = .1)
}

if(barX==TRUE){
arrows(datos3[,2]- datos3[,4], datos3[,3],datos3[,2]+ datos3[,4], datos3[,3], code = 3, col = COLORI, angle = 90, length = .1)
}





if(reg==TRUE){

if(model=="Linear"){

datos2<-data.frame(datos3[,3],datos3[,2])
colnames(datos2)<-c(varY,varX)
fo<-paste(names(datos2)[1], "~", names(datos2)[2])
reg<-lm(fo,data=datos2)
res<-residuals(reg)

if(outliers==TRUE){
resOut<- remove_outliers(res)
datosOut<-data.frame(datos3,resOut)
datos3<-na.exclude(datosOut)
datos2<-data.frame(datos3[,3],datos3[,2])
colnames(datos2)<-c(varY,varX)
fo<-paste(names(datos2)[1], "~", names(datos2)[2])
reg<-lm(fo,data=datos2)
}

Re<-summary(reg)



cx<-seq(xmin,xmax, length.out = 100)
cy<-reg$coefficients[1]+reg$coefficients[2]*cx

lines(cx,cy,  col=COLORR, lty=lty, lwd=lwd)

res<-residuals(reg)

#Normality

residshapiro<-length(res)
if(5 < residshapiro & residshapiro <5000){
Lillie<-nortest::lillie.test(res)
}
else{
Lillie<-"It was not possible to perform the Lilliefors test for normality test, n must be between 5 and 5000"
}

#Autocorrelation
DW<-lmtest::dwtest(reg)

#Homocedasticity
BreuschPagan<-lmtest::bptest(reg)


Resultados<-list("LINEAR REGRESSION",Re,"Normality", Lillie, "Autocorrelation", DW, "Homocedasticity",BreuschPagan)

print(Resultados)

if(!is.null(file1)){
sink(file1)
print(Resultados)
sink()
}
if(!is.null(R2.pos)){
legend(x=R2.pos, legend=bquote(italic(r)^2 == .(format(Re$r.squared, digits = 2, decimal.mark=dec))), bty="n", cex=1.4)
}
}#Fin Linear



if(model=="Log"){

if(min(datos3[,2])>=0.01){
datos2<-data.frame(datos3[,3],log(datos3[,2]))
colnames(datos2)<-c(varY,varX)
fo<-paste(names(datos2)[1], "~", names(datos2)[2])
reg<-lm(fo,data=datos2)
res<-residuals(reg)

if(outliers==TRUE){
resOut<- remove_outliers(res)
datosOut<-data.frame(datos3,resOut)
datos3<-na.exclude(datosOut)

datos2<-data.frame(datos3[,3],log(datos3[,2]))
colnames(datos2)<-c(varY,varX)
fo<-paste(names(datos2)[1], "~", names(datos2)[2])
reg<-lm(fo,data=datos2)
}

Re<-summary(reg)




cx<-seq(xmin,xmax, length.out = 100)
cy<-reg$coefficients[1]+reg$coefficients[2]*log(cx)

lines(cx,cy,  col=COLORR, lty=lty, lwd=lwd)

res<-residuals(reg)

#Normality

residshapiro<-length(res)
if(5 < residshapiro & residshapiro <5000){
Lillie<-nortest::lillie.test(res)
}
else{
Lillie<-"It was not possible to perform the Lilliefors test for normality test, n must be between 5 and 5000"
}

#Autocorrelation
DW<-lmtest::dwtest(reg)

#Homocedasticity
BreuschPagan<-lmtest::bptest(reg)


Resultados<-list("LOG REGRESSION",Re,"Normality", Lillie, "Autocorrelation", DW, "Homocedasticity",BreuschPagan)

print(Resultados)

if(!is.null(file1)){
sink(file1)
print(Resultados)
sink()
}
if(!is.null(R2.pos)){
legend(x=R2.pos, legend=bquote(italic(r)^2 == .(format(Re$r.squared, digits = 2, decimal.mark=dec))), bty="n", cex=1.4)
}
}#Fin si el valor de X es mayor de cero
}#Fin Log


if(model=="S-curve"){

if(min(datos3[,3])>=0.01){
datos2<-data.frame(log(datos3[,3]),1/datos3[,2])
colnames(datos2)<-c(varY,varX)
fo<-paste(names(datos2)[1], "~", names(datos2)[2])
reg<-lm(fo,data=datos2)
res<-datos3[,3]-exp(reg$coefficients[1]+reg$coefficients[2]/datos3[,2])


if(outliers==TRUE){
resOut<- remove_outliers(res)
datosOut<-data.frame(datos3,resOut)
datos3<-na.exclude(datosOut)

datos2<-data.frame(log(datos3[,3]),1/datos3[,2])
colnames(datos2)<-c(varY,varX)
fo<-paste(names(datos2)[1], "~", names(datos2)[2])
reg<-lm(fo,data=datos2)
}

Re<-summary(reg)


cx<-seq(xmin,xmax, length.out = 100)
cy<-exp(reg$coefficients[1]+reg$coefficients[2]/cx)

lines(cx,cy,  col=COLORR, lty=lty, lwd=lwd)

res<-residuals(reg)

#Normality

residshapiro<-length(res)
if(5 < residshapiro & residshapiro <5000){
Lillie<-nortest::lillie.test(res)
}
else{
Lillie<-"It was not possible to perform the Lilliefors test for normality test, n must be between 5 and 5000"
}

#Autocorrelation
DW<-lmtest::dwtest(reg)

#Homocedasticity
BreuschPagan<-lmtest::bptest(reg)


Resultados<-list("S-CURVE REGRESSION",Re,"Normality", Lillie, "Autocorrelation", DW, "Homocedasticity",BreuschPagan)

print(Resultados)

if(!is.null(file1)){
sink(file1)
print(Resultados)
sink()
}
if(!is.null(R2.pos)){
legend(x=R2.pos, legend=bquote(italic(r)^2 == .(format(Re$r.squared, digits = 2, decimal.mark=dec))), bty="n", cex=1.4)
}
}#Fin si el valor de X es mayor de cero
}#Fin S-curve


if(model=="Power"){

if(min(datos3[,3])>=0.01){
if(min(datos3[,2])>=0.01){
datos2<-data.frame(log(datos3[,3]),log(datos3[,2]))
colnames(datos2)<-c(varY,varX)
fo<-paste(names(datos2)[1], "~", names(datos2)[2])
reg<-lm(fo,data=datos2)
res<-datos3[,3]-exp(reg$coefficients[1])*datos3[,2]^reg$coefficients[2]

if(outliers==TRUE){
resOut<- remove_outliers(res)
datosOut<-data.frame(datos3,resOut)
datos3<-na.exclude(datosOut)

datos2<-data.frame(log(datos3[,3]),log(datos3[,2]))
colnames(datos2)<-c(varY,varX)
fo<-paste(names(datos2)[1], "~", names(datos2)[2])
reg<-lm(fo,data=datos2)
}

Re<-summary(reg)

cx<-seq(xmin,xmax, length.out = 100)
cy<-exp(reg$coefficients[1])*cx^reg$coefficients[2]

lines(cx,cy,  col=COLORR, lty=lty, lwd=lwd)

res<-residuals(reg)

#Normality

residshapiro<-length(res)
if(5 < residshapiro & residshapiro <5000){
Lillie<-nortest::lillie.test(res)
}
else{
Lillie<-"It was not possible to perform the Lilliefors test for normality test, n must be between 5 and 5000"
}

#Autocorrelation
DW<-lmtest::dwtest(reg)

#Homocedasticity
BreuschPagan<-lmtest::bptest(reg)


Resultados<-list("POWER REGRESSION",Re,"Normality", Lillie, "Autocorrelation", DW, "Homocedasticity",BreuschPagan)

print(Resultados)

if(!is.null(file1)){
sink(file1)
print(Resultados)
sink()
}
if(!is.null(R2.pos)){
legend(x=R2.pos, legend=bquote(italic(r)^2 == .(format(Re$r.squared, digits = 2, decimal.mark=dec))), bty="n", cex=1.4)
}
}#mini Y
}#min X
}#Fin Power


if(model=="Exp"){

if(min(datos3[,3])>=0.01){
datos2<-data.frame(log(datos3[,3]),datos3[,2])
colnames(datos2)<-c(varY,varX)
fo<-paste(names(datos2)[1], "~", names(datos2)[2])
reg<-lm(fo,data=datos2)
res<-datos3[,3]-exp(reg$coefficients[1])*exp(datos3[,2]*reg$coefficients[2])


if(outliers==TRUE){
resOut<- remove_outliers(res)
datosOut<-data.frame(datos3,resOut)
datos3<-na.exclude(datosOut)

datos2<-data.frame(log(datos3[,3]),datos3[,2])
colnames(datos2)<-c(varY,varX)
fo<-paste(names(datos2)[1], "~", names(datos2)[2])
reg<-lm(fo,data=datos2)
}

Re<-summary(reg)

cx<-seq(xmin,xmax, length.out = 100)
cy<-exp(reg$coefficients[1])*exp(cx*reg$coefficients[2])

lines(cx,cy,  col=COLORR, lty=lty, lwd=lwd)

res<-residuals(reg)

#Normality

residshapiro<-length(res)
if(5 < residshapiro & residshapiro <5000){
Lillie<-nortest::lillie.test(res)
}
else{
Lillie<-"It was not possible to perform the Lilliefors test for normality test, n must be between 5 and 5000"
}

#Autocorrelation
DW<-lmtest::dwtest(reg)

#Homocedasticity
BreuschPagan<-lmtest::bptest(reg)


Resultados<-list("EXPONENTIAL REGRESSION",Re,"Normality", Lillie, "Autocorrelation", DW, "Homocedasticity",BreuschPagan)

print(Resultados)

if(!is.null(file1)){
sink(file1)
print(Resultados)
sink()
}
if(!is.null(R2.pos)){
legend(x=R2.pos, legend=bquote(italic(r)^2 == .(format(Re$r.squared, digits = 2, decimal.mark=dec))), bty="n", cex=1.4)
}
}#Fin si el valor de X es mayor de cero
}#Fin Exp


if(model=="Quadratic"){

datos2<-data.frame(datos3[,3],datos3[,2],datos3[,2]^2)
colnames(datos2)<-c(varY,varX,paste(varX,"2",sep=""))
fo<-paste(names(datos2)[1], "~", names(datos2)[2],"+",names(datos2)[3])
reg<-lm(fo,data=datos2)
res<-residuals(reg)

if(outliers==TRUE){
resOut<- remove_outliers(res)
datosOut<-data.frame(datos3,resOut)
datos3<-na.exclude(datosOut)

datos2<-data.frame(datos3[,3],datos3[,2],datos3[,2]^2)
colnames(datos2)<-c(varY,varX,paste(varX,"2",sep=""))
fo<-paste(names(datos2)[1], "~", names(datos2)[2],"+",names(datos2)[3])
reg<-lm(fo,data=datos2)
}

Re<-summary(reg)


cx<-seq(xmin,xmax, length.out = 100)
cy<-reg$coefficients[1]+reg$coefficients[2]*cx+reg$coefficients[3]*cx^2

lines(cx,cy,  col=COLORR, lty=lty, lwd=lwd)

res<-residuals(reg)

#Normality
residshapiro<-length(res)
if(5 < residshapiro & residshapiro <5000){
Lillie<-nortest::lillie.test(res)
}
else{
Lillie<-"It was not possible to perform the Lilliefors test for normality test, n must be between 5 and 5000"
}

#Autocorrelation
DW<-lmtest::dwtest(reg)

#Homocedasticity
BreuschPagan<-lmtest::bptest(reg)


Resultados<-list("QUADRATIC REGRESSION",Re,"Normality", Lillie, "Autocorrelation", DW, "Homocedasticity",BreuschPagan)

print(Resultados)

if(!is.null(file1)){
sink(file1)
print(Resultados)
sink()
}
if(!is.null(R2.pos)){
legend(x=R2.pos, legend=bquote(italic(r)^2 == .(format(Re$r.squared, digits = 2, decimal.mark=dec))), bty="n", cex=1.4)
}
}#Fin Quadratic

if(model=="Cubic"){

datos2<-data.frame(datos3[,3],datos3[,2],datos3[,2]^2,datos3[,2]^3)
colnames(datos2)<-c(varY,varX,paste(varX,"2",sep=""),paste(varX,"3",sep=""))
fo<-paste(names(datos2)[1], "~", names(datos2)[2],"+",names(datos2)[3],"+",names(datos2)[4])
reg<-lm(fo,data=datos2)
res<-residuals(reg)

if(outliers==TRUE){
resOut<- remove_outliers(res)
datosOut<-data.frame(datos3,resOut)
datos3<-na.exclude(datosOut)

datos2<-data.frame(datos3[,3],datos3[,2],datos3[,2]^2,datos3[,2]^3)
colnames(datos2)<-c(varY,varX,paste(varX,"2",sep=""),paste(varX,"3",sep=""))
fo<-paste(names(datos2)[1], "~", names(datos2)[2],"+",names(datos2)[3],"+",names(datos2)[4])
reg<-lm(fo,data=datos2)
}

Re<-summary(reg)


cx<-seq(xmin,xmax, length.out = 100)
cy<-reg$coefficients[1]+reg$coefficients[2]*cx+reg$coefficients[3]*cx^2+reg$coefficients[4]*cx^3

lines(cx,cy,  col=COLORR, lty=lty, lwd=lwd)

res<-residuals(reg)

#Normality

residshapiro<-length(res)
if(5 < residshapiro & residshapiro <5000){
Lillie<-nortest::lillie.test(res)
}
else{
Lillie<-"It was not possible to perform the Lilliefors test for normality test, n must be between 5 and 5000"
}

#Autocorrelation
DW<-lmtest::dwtest(reg)

#Homocedasticity
BreuschPagan<-lmtest::bptest(reg)


Resultados<-list("CUBIC REGRESSION",Re,"Normality", Lillie, "Autocorrelation", DW, "Homocedasticity",BreuschPagan)

print(Resultados)

if(!is.null(file1)){
sink(file1)
print(Resultados)
sink()
}
if(!is.null(R2.pos)){
legend(x=R2.pos, legend=bquote(italic(r)^2 == .(format(Re$r.squared, digits = 2, decimal.mark=dec))), bty="n", cex=1.4)
}
}#Fin Cubic



if(model=="Inverse"){

if(is.na(match(0,datos3[,2]))){
datos2<-data.frame(datos3[,3],1/datos3[,2])
colnames(datos2)<-c(varY,varX)
fo<-paste(names(datos2)[1], "~", names(datos2)[2])
reg<-lm(fo,data=datos2)
res<-residuals(reg)

if(outliers==TRUE){
resOut<- remove_outliers(res)
datosOut<-data.frame(datos3,resOut)
datos3<-na.exclude(datosOut)

datos2<-data.frame(datos3[,3],1/datos3[,2])
colnames(datos2)<-c(varY,varX)
fo<-paste(names(datos2)[1], "~", names(datos2)[2])
reg<-lm(fo,data=datos2)
}

Re<-summary(reg)


cx<-seq(xmin,xmax, length.out = 100)
cy<-reg$coefficients[1]+reg$coefficients[2]*1/cx

lines(cx,cy,  col=COLORR, lty=lty, lwd=lwd)

res<-residuals(reg)

#Normality

residshapiro<-length(res)
if(5 < residshapiro & residshapiro <5000){
Lillie<-nortest::lillie.test(res)
}
else{
Lillie<-"It was not possible to perform the Lilliefors test for normality test, n must be between 5 and 5000"
}

#Autocorrelation
DW<-lmtest::dwtest(reg)

#Homocedasticity
BreuschPagan<-lmtest::bptest(reg)


Resultados<-list("INVERSE REGRESSION",Re,"Normality", Lillie, "Autocorrelation", DW, "Homocedasticity",BreuschPagan)

print(Resultados)

if(!is.null(file1)){
sink(file1)
print(Resultados)
sink()
}
if(!is.null(R2.pos)){
legend(x=R2.pos, legend=bquote(italic(r)^2 == .(format(Re$r.squared, digits = 2, decimal.mark=dec))), bty="n", cex=1.4)
}
}#Fin si el valor de X es mayor de cero
}#Fin Inverse



}#Fin regresion

if(textlabel==TRUE){
if(!is.null(label)){
tx<-paste("text(","x=datos3[,2],", "y=datos3[,3],", "labels=datos3[,1],", toString(x=label), ")")
eval(parse(text=tx))
}
else{
tx<-paste("text(","x=datos3[,2],", "y=datos3[,3],", "labels=datos3[,1],", "pos=4", ")")
eval(parse(text=tx))
}
}


if(!is.null(LEGEND)){
legendexe<-paste("legend(",toString(x=LEGEND), ")")
eval(parse(text=legendexe))
}
else{
}


if(!is.null(AXIS)){
axisexe<-paste("axis(",toString(x=AXIS), ")")
eval(parse(text=axisexe))
}
else{
}

if(!is.null(MTEXT)){
mtextexe<-paste("mtext(",toString(x=MTEXT), ")")
eval(parse(text=mtextexe))
}
else{
}

if(!is.null(TEXT)){
textexe<-paste("text(",toString(x=TEXT), ")")
eval(parse(text=textexe))
}
else{
}



}
