F30<-function(data, X, Y, Z, matrix=FALSE, theta=120, phi=20, ticktype="detailed",
shade=0.5, scale=TRUE, PERSP=NULL, ResetPAR=TRUE, PAR=NULL,
XLAB=NULL, YLAB=NULL, ZLAB=NULL, XLIM=NULL, YLIM=NULL,
ZLIM=NULL, COLOR="white", LEGEND=NULL, MTEXT= NULL, TEXT=NULL){


###############################################
#Seccion que realiza el procedimiento
###############################################

datos<-data


datosT<-data.frame(subset(datos, select=X), subset(datos, select=Y), subset(datos, select=Z))


datos<-na.exclude(datosT)


if(ResetPAR==TRUE){
#Resetear par() a las opciones por defecto
resetPar <- function() {
    dev.new()
    op <- par(no.readonly = TRUE)
    dev.off()
    op
}
par(resetPar()) }
else{
}


if(!is.null(XLAB)) xlab<-XLAB else xlab<-X
if(!is.null(YLAB)) ylab<-YLAB else ylab<-Y


if(!is.null(PAR)){
parexe<-paste("par(new,",toString(x=PAR), ")")
eval(parse(text=parexe))
}
else{
par(font.lab=2, mar=c(5,5,3,2),cex.lab=1)
}

x<-datos[,X]
y<-datos[,Y]

if(matrix==FALSE){
if(!is.null(ZLAB)) zlab<-ZLAB else zlab<-Z
z<-datos[,Z]
}
else{
if(!is.null(ZLAB)) zlab<-ZLAB else zlab<-"Z"
z<-as.matrix(datos[,Z])
}



if(!is.null(XLIM)) xlim<-XLIM else xlim<-range(x, na.rm = TRUE)
if(!is.null(YLIM)) ylim<-YLIM else ylim<-range(y, na.rm = TRUE)
if(!is.null(ZLIM)) zlim<-ZLIM else zlim<-range(z, na.rm = TRUE)


if(matrix==FALSE){

input<-akima::interp(x,y,z)

if(!is.null(PERSP)){
plotexe<-paste("persp(","x=input,", toString(x=PERSP), ")")
eval(parse(text=plotexe))
}
else{
plotexe<-paste("persp(",",x=input,", "theta = theta,",
"phi = phi,", "xlab=xlab,", "ylab=ylab,", "zlab=zlab,", "scale = scale,",  "box=TRUE,", 
"xlim=xlim,","ylim=ylim,","zlim=zlim,", "border=NA,", "shade=shade,", "ticktype=ticktype,", "col=COLOR",")")
eval(parse(text=plotexe))
}
}
else{
if(!is.null(PERSP)){
plotexe<-paste("persp(","x=x,","y=y,", "z=z,", toString(x=PERSP), ")")
eval(parse(text=plotexe))
}
else{
plotexe<-paste("persp(",",x=x,","y=y,", "z=z,", "theta = theta,",
"phi = phi,", "xlab=xlab,", "ylab=ylab,", "zlab=zlab,", "scale = scale,", "box=TRUE,",
"xlim=xlim,","ylim=ylim,","zlim=zlim,", "border=NA,", "shade=shade,", "ticktype=ticktype,", "col=COLOR",")")
eval(parse(text=plotexe))
}
}



if(!is.null(LEGEND)){
legendexe<-paste("legend(",toString(x=LEGEND), ")")
eval(parse(text=legendexe))
}
else{
}



if(!is.null(MTEXT)){
mtextexe<-paste("mtext(",toString(x=MTEXT), ")")
eval(parse(text=mtextexe))
}
else{
}

if(!is.null(TEXT)){
textexe<-paste("text(",toString(x=TEXT), ")")
eval(parse(text=textexe))
}
else{
}


}
