F44<-function(data, variable, group, group1, row, ResetPAR=TRUE,  PAR=NULL, HIST=NULL,
colorp="red", pch=18, cex=2, colorb="lightblue", breaks=10, LEGEND=NULL, AXIS=NULL,
MTEXT= NULL, TEXT=NULL, file="Output.txt"){


###############################################
#Seccion que realiza el procedimiento
###############################################


datos<-data

datos<-data.frame(subset(datos, select=variable), subset(datos, select=group))


grupo1<-na.exclude(subset(datos,(datos[, group] == group1)))


if(ResetPAR==TRUE){
#Resetear par() a las opciones por defecto
resetPar <- function() {
    dev.new()
    op <- par(no.readonly = TRUE)
    dev.off()
    op
}
par(resetPar()) }
else{
}

if(!is.null(PAR)){
parexe<-paste("par(new,",toString(x=PAR), ")")
eval(parse(text=parexe))
}
else{
par(font.lab=2, mar=c(5,5,3,2),cex.lab=1.5)
}



rand1<-ade4::as.randtest(as.numeric(grupo1[,1]), as.numeric(datos[row,1]), alter="less") 

rand2<-ade4::as.randtest(as.numeric(grupo1[,1]), as.numeric(datos[row,1]), alter="greater") 

valor<-as.character(datos[row,group])


sim<-as.numeric(grupo1[,1])
obs<-as.numeric(datos[row,1])
r0 <- c(sim, obs)
l0 <- max(sim, na.rm=TRUE) - min(sim, na.rm=TRUE)
w0 <- l0/(log(length(sim), base = 2) + 1)
xlim0 <- range(r0) + c(-w0, w0)
h0 <- hist(sim, plot = FALSE, nclass = breaks)
y0 <- max(h0$counts, na.rm=TRUE)

print(c(group,valor))
print(c("Observation row:",row))
print(c("Observation value:",datos[row,variable]))
print("")
print("ALTERNATIVE HYPOTHESIS: PROBABILITY OF BEING SMALLER")
print(rand1)
print("")
print("ALTERNATIVE HYPOTHESIS: PROBABILITY OF BEING GREATER")
print(rand2)

if(!is.null(HIST)){
textexe<-paste("hist(","x=sim,", toString(x=HIST), ")")
eval(parse(text=textexe))
}
else{
textexe<-paste("hist(","x=sim,", "xlab=variable,", "xlim = xlim0,", "breaks=breaks,","col=colorb,", "main=''", ")")
eval(parse(text=textexe))
}

lines(c(obs, obs), c(y0/2, 0))
points(obs, y0/2, pch = pch, cex = cex, col=colorp)

if(!is.null(LEGEND)){
legendexe<-paste("legend(",toString(x=LEGEND), ")")
eval(parse(text=legendexe))
}
else{
}


if(!is.null(AXIS)){
axisexe<-paste("axis(",toString(x=AXIS), ")")
eval(parse(text=axisexe))
}
else{
}

if(!is.null(MTEXT)){
mtextexe<-paste("mtext(",toString(x=MTEXT), ")")
eval(parse(text=mtextexe))
}
else{
}

if(!is.null(TEXT)){
textexe<-paste("text(",toString(x=TEXT), ")")
eval(parse(text=textexe))
}
else{
}


if(!is.null(file)){
sink(file)
print(c(group,valor))
print(c("Observation row:",row))
print(c("Observation value:",datos[row,variable]))
print("")
print("ALTERNATIVE HYPOTHESIS: PROBABILITY OF BEING SMALLER")
print(rand1)
print("")
print("ALTERNATIVE HYPOTHESIS: PROBABILITY OF BEING GREATER")
print(rand2)
sink()
}

}
