F45<-function(data, variable1, variable2, group, group1, row, ResetPAR=TRUE,  PAR=NULL, BIVTEST=NULL, 
Pcol="red", colbiv="lightblue", br=20, sub="", 
LEGEND=NULL, AXIS=NULL,
MTEXT= NULL, TEXT=NULL, TEXTX=NULL, TEXTY=NULL){


###############################################
#Seccion que realiza el procedimiento
###############################################

#Paquetes necesarios


datos<-data

datos<-data.frame(subset(datos, select=variable1), subset(datos, select=variable2), subset(datos, select=group))



grupo1<-na.exclude(subset(datos,(datos[, group] == group1)))

if(ResetPAR==TRUE){
#Resetear par() a las opciones por defecto
resetPar <- function() {
    dev.new()
    op <- par(no.readonly = TRUE)
    dev.off()
    op
}
par(resetPar()) }
else{
}

if(!is.null(PAR)){
parexe<-paste("par(new,",toString(x=PAR), ")")
eval(parse(text=parexe))
}
else{
par(font.lab=2, mar=c(5,5,3,2),cex.lab=1.5)
}



rand1<-ade4::as.randtest(as.numeric(grupo1[,1]), as.numeric(datos[row,1]), alter="less") 

rand2<-ade4::as.randtest(as.numeric(grupo1[,1]), as.numeric(datos[row,1]), alter="greater") 

valor<-as.character(datos[row,group])

sim<-as.numeric(grupo1[,1])
obs<-as.numeric(datos[row,1])



print(c(group,valor))
print(c("Observation row:",row))
print(c("Observation value:",datos[row,1],datos[row,2]))



point<- c(datos[row,1],datos[row,2])

if(!is.null(BIVTEST)){
tx<-paste("adehabitatHS::biv.test(","dfxy=grupo1[,1:2],", "point=point,",  toString(x=BIVTEST), ")")
eval(parse(text=tx))
}
else{
tx<-paste("adehabitatHS::biv.test(","dfxy=grupo1[,1:2],", "point=point,", "br=br,",
"Pcol=Pcol,", "col=colbiv,", "sub=sub", ")")
eval(parse(text=tx))
}


dati<-c(as.character(datos[row,3]),group1)

col<-c(Pcol, colbiv)

if(!is.null(LEGEND)){
if(LEGEND==FALSE){
}
else{
legendexe<-paste("legend(",toString(x=LEGEND), ")")
eval(parse(text=legendexe))
}
}
else{
legendexe<-paste("legend(","x='topright',","legend=dati,","bty='n',", "col=col,","pch=c(16,16)",  ")")
eval(parse(text=legendexe))
}


if(!is.null(AXIS)){
axisexe<-paste("axis(",toString(x=AXIS), ")")
eval(parse(text=axisexe))
}
else{
}

if(!is.null(MTEXT)){
mtextexe<-paste("mtext(",toString(x=MTEXT), ")")
eval(parse(text=mtextexe))
}
else{
}

if(!is.null(TEXT)){
textexe<-paste("text(",toString(x=TEXT), ")")
eval(parse(text=textexe))
}
else{
}


if(!is.null(TEXTY)){
if(TEXTY==FALSE){
}
textexe<-paste("text(",toString(x=TEXTY), ")")
eval(parse(text=textexe))
}
else{
textexe<-paste("text(","x=0.85,", "y=0.7,","label=variable2,", "font=2", ")")
eval(parse(text=textexe))
}

if(!is.null(TEXTX)){
if(TEXTX==FALSE){
}
textexe<-paste("text(",toString(x=TEXTX), ")")
eval(parse(text=textexe))
}
else{
textexe<-paste("text(","x=0.7,", "y=0.85,","label=variable1,", "font=2", ")")
eval(parse(text=textexe))
}


}
