F64<-function(data, varY, varX, IPLOT=NULL, pixs=3, MAX="zmax", ResetPAR=TRUE,  PAR=NULL, XLAB=NULL, YLAB=NULL, COLOR=IDPcolorRamp, MTEXT= NULL, TEXT=NULL){


###############################################
#Seccion que realiza el procedimiento
###############################################

datos<-data

datosT<-data.frame(subset(datos, select=varY), subset(datos, select=varX))

datos<-na.exclude(datosT)

require(IDPmisc)


if(ResetPAR==TRUE){
#Resetear par() a las opciones por defecto
resetPar <- function() {
    dev.new()
    op <- par(no.readonly = TRUE)
    dev.off()
    op
}
par(resetPar()) }
else{
}


if(!is.null(PAR)){
parexe<-paste("par(new,",toString(x=PAR), ")")
eval(parse(text=parexe))
}
else{
par(font.lab=2, mar=c(5,5,3,2),cex.lab=1.5)
}

if(!is.null(XLAB)) xlab<-XLAB else xlab<-varX
if(!is.null(YLAB)) ylab<-YLAB else ylab<-varY



write.table(15,"Pointsize.dat", row.names=FALSE,col.names=FALSE)

if(!is.null(MAX)){
if(MAX=="zmax"){
MAX<-iplot(x=datos[,varX], y=datos[,varY], pixs=pixs,
xlab=xlab, ylab=ylab, colramp=COLOR)
}
else{
MAX<-MAX
}
}


devact<-dev.cur()

if(devact==3){
dev.off()
}

if(!is.null(IPLOT)){
plotexe<-paste("iplot(","x=datos[,varX],", "y=datos[,varY],",  toString(x=IPLOT), ")")
eval(parse(text=plotexe))
}
else{
plotexe<-paste("iplot(","x=datos[,varX],", "y=datos[,varY],",  "pixs=pixs,", "zmax=MAX,",
"xlab=xlab,", "ylab=ylab,","colramp=COLOR", ")")
eval(parse(text=plotexe))
}




if(!is.null(MTEXT)){
mtextexe<-paste("mtext(",toString(x=MTEXT), ")")
eval(parse(text=mtextexe))
}
else{
}

if(!is.null(TEXT)){
textexe<-paste("text(",toString(x=TEXT), ")")
eval(parse(text=textexe))
}
else{
}


}
