F66<-function(data, date, var, winds=NULL, windd=NULL, year, month, 
date.format="%d/%m/%Y %H:%M", annotate="date", key.position="right",
COLOR="heat", MAIN=NULL, CEX.LIM=c(0.6,1), BREAKS=FALSE,
LABELS=NULL, STATISTIC="mean", CALENDAR=NULL,  dec=","){


###############################################
#Seccion que realiza el procedimiento
###############################################



datos<-data

##  various check to make sure all the data are available ##

if(!is.null(winds)){
if(var==winds) stop("Error: var and winds cannot be the same variable")
}

if(!is.null(windd)){
if(var==windd) stop("Error: var and windd cannot be the same variable")
}

if(is.null(winds) | is.null(windd)){
if(annotate=="ws")  stop("Error: It is necessary to specify both variables windd (wind direction) and winds (wind speed)")
}

if(is.null(windd) | is.null(winds)){
if(annotate=="wd")  stop("Error: It is necessary to specify both variables windd (wind direction) and winds (wind speed)")
}



####End check

cn<-colnames(datos)
pos<-which(cn==date)
colnames(datos)[pos]<-"date"

if(!is.null(winds)){
pos<-which(cn==winds)
colnames(datos)[pos]<-"ws"
}



if(!is.null(windd)){
pos<-which(cn==windd)
colnames(datos)[pos]<-"wd"
}



if(class(datos$date)=="Date" | class(datos$date)=="POSIXt" | class(datos$date)=="POSIXct"){
if(date.format=="%d/%m/%Y %H:%M"){
datos$date<-paste(x=format(datos$date, "%d"),"/",format(datos$date, "%m"),"/",
format(datos$date, "%Y"), " " ,format(datos$date, "%H"), ":", format(datos$date, "%M"), sep="")
}

if(date.format=="%d/%m/%Y"){
datos$date<-paste(x=format(datos$date, "%d"),"/",format(datos$date, "%m"),"/",
format(datos$date, "%Y"), sep="")
}

if(date.format=="%Y/%m/%d %H:%M"){
datos$date<-paste(x=format(datos$date, "%d"),"/",format(datos$date, "%m"),"/",
format(datos$date, "%Y"), " " ,format(datos$date, "%H"), ":", format(datos$date, "%M"), sep="")
}

if(date.format=="%Y/%m/%d"){
datos$date<-paste(x=format(datos$date, "%d"),"/",format(datos$date, "%m"),"/",
format(datos$date, "%Y"), sep="")
}

}



if(date.format=="%Y/%m/%d %H:%M"){ date.format<-"%d/%m/%Y %H:%M"}

if(date.format=="%Y/%m/%d"){ date.format<-"%d/%m/%Y"}


if(dec=="."){
write.csv(x=datos,file = "Temp.csv", row.names=FALSE, sep=",", na="")
}
else{
write.csv2(x=datos,file = "Temp.csv", row.names=FALSE, sep=";", na="")
}


if(dec=="."){
datos<-openair::import(file="Temp.csv", sep=",", date.format=date.format)
}
else{
datos<-openair::import(file="Temp.csv", sep=";", date.format=date.format)
}


if(class(datos$date)=="factor" | class(datos$date)=="character"){
datos$date<-as.POSIXct(strptime(datos$date, format = date.format))
}

if (missing(CALENDAR)) CALENDAR=NULL else CALENDAR=CALENDAR
if (missing(year)) {
year <- as.numeric(format(datos$date[1], "%Y"))
warning (paste("'year not supplied, using'", year))
}
else{
datos<-openair::selectByDate(datos, year = year)
}
if (missing(month)) {
month<-as.vector(unique(as.numeric(format(datos$date, "%m"))))
warning (paste("'year not supplied, using'", month))
}
else{
datos<-openair::selectByDate(datos, month = month)
}



if(!is.null(MAIN)){
main<-MAIN
}
else{
MAIN<-paste(var,"-",year, sep=" ")
}

if(class(BREAKS)=="logical"){
if(BREAKS==FALSE){
breaks<-NA
labels<-NA
}
else{
ifelse(!is.null(LABELS), labels<-LABELS, labels<-c("Very low", "Low", "Medium", "High", "Very High"))

ifelse(COLOR=="heat", COLOR<-COLOR, COLOR<-heat.colors(5))

cn1<-colnames(datos)

DAY<-format(datos$date, "%d")

MONTH<-format(datos$date, "%m")

YEAR<-format(datos$date, "%Y")

datos1<-data.frame(DAY,MONTH,YEAR,datos)


if(dec=="."){
write.csv(x=datos1,file = "Temp.csv", row.names=FALSE, sep=",", na="")
}
else{
write.csv2(x=datos1,file = "Temp.csv", row.names=FALSE, sep=";", na="")
}


if(dec=="."){
datos2<-read.csv(file = "Temp.csv", header=TRUE)
}
else{
datos2<-read.csv2(file = "Temp.csv", header=TRUE)
}

timemean<-aggregate(datos2[,var],by=list(datos2$DAY,datos2$MONTH,datos2$YEAR),STATISTIC, na.rm=TRUE)

rango<-range(timemean[,4], na.rm=TRUE, finite=TRUE)
breaks<-seq(rango[1], rango[2], by=(rango[2]-rango[1])/5)

}
}
else{
breaks<-BREAKS
labels<-LABELS
}




cn<-colnames(datos)
pos<-which(cn=="date")

datos2<-datos

datos1<-datos[,-pos]

if(dec=="."){
write.csv(x=datos1,file = "Temp.csv", row.names=FALSE, sep=",", na="")
}
else{
write.csv2(x=datos1,file = "Temp.csv", row.names=FALSE, sep=";", na="")
}


if(dec=="."){
datos1<-read.csv(file="Temp.csv")
}
else{
datos1<-read.csv2(file="Temp.csv")
}

datos<-cbind(datos2[,pos],datos1)
cn<-colnames(datos1)

colnames(datos)<-c("date",cn)

remove(datos1)

remove(datos2)

if(!is.null(CALENDAR)){
prose<-paste("openair::calendarPlot(","mydata=datos,", "pollutant=var,", "year=year,",  "month=month,", toString(x=CALENDAR), ")")
eval(parse(text=prose))
}
else{
prose<-paste("openair::calendarPlot(","mydata=datos,", "pollutant=var,", "year=year,", "month=month,",
"annotate=annotate,", "cols=COLOR,", "main=MAIN,", "cex.lim=CEX.LIM,",
"breaks=breaks,", "labels=labels,", "statistic=STATISTIC",  ")")
eval(parse(text=prose))
}





}
