F71<-function(data, X, Y,  Z,  SURFACE=NULL, axes=FALSE, AXES=NULL,
MTEXT=NULL, TITLE=NULL, XLAB="", YLAB="", ZLAB="", MAIN=NULL, SUB=NULL,
LINE=NA, COL=NULL, COLT="black", FONT=2, CEX=1.5){

datos<-data

if(missing(X)){
z<-as.matrix(datos)
x <- (1:nrow(z))
y <- (1:ncol(z))
}
else{
if(class(Z)=="matrix") z<-Z else z<-as.matrix(datos[Z])
x<-datos[,X]
y<-datos[,Y]
}

zlim<-range(z)
zlen<-zlim[2]-zlim[1]+1
colorlut<-terrain.colors(zlen,alpha=0)
col<-colorlut[z-zlim[1]+1]

#if(is.null(COL)) col=col else col=COL
if(is.null(XLAB)) xlab=X else xlab=XLAB
if(is.null(YLAB)) ylab=Y else ylab=YLAB
if(is.null(ZLAB)) zlab=Z else zlab=ZLAB


rgl::open3d()

if(!is.null(SURFACE)){
tx<-paste("rgl::rgl.surface(", "x=x,", "z=y,", "y=z,",   toString(x=SURFACE), ")")
eval(parse(text=tx))
}
else{
tx<-paste("rgl::rgl.surface(", "x=x,", "z=y,", "y=z,","color=col", ")")
eval(parse(text=tx))
}

if(!is.null(TITLE)){
tx<-paste("rgl::title3d(",  toString(x=TITLE), ")")
eval(parse(text=tx))
}
else{
tx<-paste("rgl::title3d(", "main = MAIN,", "sub = SUB,",  "xlab = xlab,", "ylab = zlab,",
"zlab = ylab,", "line = LINE,", "col=COLT,", "font=FONT,", "cex=CEX", ")")
eval(parse(text=tx))
}

rgl::title3d(main = MAIN, sub = SUB, xlab = xlab, ylab = zlab,
zlab = ylab, line = LINE, col=COLT, font=FONT, cex=CEX)

if(axes==TRUE){
if(!is.null(AXES)){
tx<-paste("rgl::axes3d(",   toString(x=AXES), ")")
eval(parse(text=tx))
}
else{
tx<-paste("rgl::axes3d(", "col=COLT,", ")")
eval(parse(text=tx))
}
}

if(!is.null(MTEXT)){
tx<-paste("rgl::mtext3d(",   toString(x=MTEXT), ")")
eval(parse(text=tx))
}


}
