F80<-function(data, var, kernel="gaussian", PLOT=NULL, overlap=TRUE, lty=1, lwd=2.5, 
ResetPAR=TRUE,  PAR=NULL, XLAB=NULL, XLIM=NULL,YLIM=NULL, COLOR=NULL, COLORB=NULL, 
AXIS=NULL, CEX=1.2, file="Output.csv",  na="NA", dec=",", row.names=FALSE){


###############################################
#Seccion que realiza el procedimiento
###############################################

datos<-data

datos<-data.frame(subset(datos, select=var))

if(ResetPAR==TRUE){
#Resetear par() a las opciones por defecto
resetPar <- function() {
    dev.new()
    op <- par(no.readonly = TRUE)
    dev.off()
    op
}
par(resetPar()) }
else{
}



if(!is.null(PAR)){
parexe<-paste("par(new,",toString(x=PAR), ")")
eval(parse(text=parexe))
}
else{
}


datas<-datos

if(!is.null(COLORB)){
}
else{
COLORB<-rainbow(length(var))
}


if(!is.null(COLOR)){
}
else{
COLOR<-rainbow(length(var))
}



if(!is.null(XLAB)) xlab<-XLAB else xlab<-""





if(!is.null(XLIM)){
}
else{
maxx<-max(datos, na.rm=TRUE)
minx<-min(datos, na.rm=TRUE)
XLIM<-c(minx,maxx)
}


dati<-as.character(unique(var))


c<-max(nchar(dati),na.rm=TRUE)+1

catn<-length(unique(var))

maxden<-0

for(h in 1:catn){
den<-density(na.exclude(datos[,var[h]]), kernel=kernel)
maxd<-max(den$y, na.rm=TRUE)
if(maxd>maxden) maxden<-maxd else maxden<-maxden
}


if(!is.null(YLIM)){
}
else{

YLIM<-c(0,maxden)
}



llty<-length(lty)

if(llty==1){
pch1<-lty
for (t in 2:catn){
pcht<-lty
pch1<-append(pch1,pcht)
}
lty<-pch1
}
else{
}

div<-30/catn

par(mfrow=c(catn,1))

for(h in 1:catn){

if(h==1){
par(mar=c(0,c,0,3),cex.main=1.5)

if(!is.null(PLOT)){
tx<-paste("plot.default(","x=0,", "y=0,", "axes=FALSE,", "type='n',", toString(x=PLOT), ")")
eval(parse(text=tx))
}
else{
tx<-paste("plot.default(","x=0,", "y=0,", "type='n',",
"xlim=XLIM,", "ylim=YLIM,", "xlab='',", "ylab='',", "axes=FALSE,","main=''", ")")
eval(parse(text=tx))
}
mtext(text = var[h] , side = 2 ,  adj = 1, cex=CEX, font=2, las=2)

}

if(h>1 & h<catn){
par(mar=c(0,c,0,3),cex.main=1.5)

if(!is.null(PLOT)){
tx<-paste("plot.default(","x=0,", "y=0,", "axes=FALSE,", "type='n',", toString(x=PLOT), ")")
eval(parse(text=tx))
}
else{
tx<-paste("plot.default(","x=0,", "y=0,", "type='n',",
"xlim=XLIM,", "ylim=YLIM,", "xlab='',", "ylab='',", "axes=FALSE,","main=''", ")")
eval(parse(text=tx))
}
mtext(text = var[h] , side = 2 ,  adj = 1,cex=CEX, font=2, las=2)

}

if(h==catn){
if(!is.null(XLAB)) d<-3.5 else d<-2.5
par(mar=c(d,c,0,3),cex.main=1.5)

if(!is.null(PLOT)){
tx<-paste("plot.default(","x=0,", "y=0,", "axes=FALSE,", "type='n',", toString(x=PLOT), ")")
eval(parse(text=tx))
}
else{
tx<-paste("plot.default(","x=0,", "y=0,", "axes=FALSE,", "type='n',",
"xlim=XLIM,", "ylim=YLIM,", "xlab='',", "ylab='',", "main=''", ")")
eval(parse(text=tx))
}
mtext(text = var[h] , side = 2 ,  adj =1, cex=CEX, font=2, las=2)
mtext(text = xlab , side = 1 ,  cex=CEX+0.1, font=2, line=2.5)
}


den<-density(na.exclude(datos[,var[h]]), kernel=kernel)
polygon(x=den$x, y=den$y, col=COLOR[h],border=COLORB[h], lwd=lwd,lty=lty[h])
}


par(cex.axis=1.1)

if(!is.null(AXIS)){
tx<-paste("axis(","side=1,", toString(x=AXIS), ")")
eval(parse(text=tx))
}
else{
tx<-paste("axis(","side=1", ")")
eval(parse(text=tx))
}


if(overlap==TRUE){

Variable1<-"M"
Overlap<-1
Variable2<-"M"

minimo<-min(datos[,var], na.rm=TRUE)
maximo<-max(datos[,var], na.rm=TRUE)
for(h in 1:catn){
d1<-density(na.exclude(datos[,var[h]]), from=minimo, to=maximo, kernel=kernel)
for(i in 1:catn){
d2<-density(na.exclude(datos[,var[i]]), from=minimo, to=maximo, kernel=kernel)
p<-d1$y-d2$y
p[which(p<0)]=0
p3<-d1$y-p
p3[which(p3<0)]=0
auc1<-kulife::auc(d1$x,d1$y)
auc3<-kulife::auc(d1$x,p3)
P1<-auc3*100/auc1
if(var[h]==var[i]){
}
else{
Variable1<-append(Variable1,var[h])
Variable2<-append(Variable2,var[i])
Overlap<-append(Overlap,P1)
}
}
}
}

salida<-data.frame(Variable1[-1],Overlap[-1],Variable2[-1])


colnames(salida)<-c("Variable1","Overlap","Variable2")

print(salida)

if(dec=="."){
write.csv(x=salida,file = file, fileEncoding = "", row.names=row.names,na=na)
}
else{
write.csv2(x = salida,file = file, fileEncoding = "", row.names=row.names,na=na)
}



}
