F84<-function(data, varX, varY, varY1=NULL, varY2=NULL, varY3=NULL, textlabelY=NULL, textlabelY1=NULL, textlabelY2=NULL,
textlabelY3=NULL, type=NULL, label=NULL, MAR1=c(5,5,3,4), MAR2=c(5,5,3,8), MAR3=c(5,5,3,12),
reg=FALSE, model=NULL, outliers=FALSE, quant1=0.05,
quant2 = 0.95,  ResetPAR=TRUE, PAR=NULL, XLAB=NULL, YLAB=NULL, YLAB1=NULL, YLAB2=NULL,YLAB3=NULL, XLIM=NULL,
YLIM=NULL, YLIM1=NULL, YLIM2=NULL, YLIM3=NULL, CEX=1.2, FONTLAB=2, CEXLAB=1.5, COLOR=NULL, COLORR=NULL, PCH=NULL, lty=NULL, 
 ltyL=NULL, lwd=2.5, lwdL=1,  LEGEND=NULL,  MTEXT= NULL, TEXT=NULL, file="Output.txt"){



############
#################Function to add axes
############

AA<-function(data, varY,  varX, textlabel=NULL, type=NULL, label=NULL, reg=FALSE, model=NULL, outliers=FALSE, quant1=0.05,
quant2 = 0.95,  PAR=NULL, XLAB=NULL, YLAB=NULL, XLIM=NULL,
YLIM=NULL,  CEX=1.2,
COLOR=NULL, COLORR=NULL, PCH=NULL, lty=NULL,   ltyL=NULL, lwd=2.5, lwdL=1,
PLOT=NULL,  file="Output.txt"){


datos<-data

if (missing(textlabel)) textlabel=NULL else textlabel=textlabel
if (missing(label)) label=NULL else label=label

datosT<-data.frame(subset(datos, select=varY), subset(datos, select=varX))

if(!is.null(textlabel)){
datosT<-data.frame(subset(datos, select=varY), subset(datos, select=varX), subset(datos, select=textlabel))
}

if(!is.null(varY1)){
datosT<-data.frame(datosT, subset(datos, select=varY1))
}

if(!is.null(varY2)){
datosT<-data.frame(datosT, subset(datos, select=varY2))
}

if(!is.null(varY3)){
datosT<-data.frame(datosT, subset(datos, select=varY3))
}

datos<-na.exclude(datosT)


if(!is.null(XLIM)){
}
else{
maxx<-max(datos[,varX],na.rm=TRUE)
minn<-min(datos[,varX],na.rm=TRUE)
XLIM<-c(minn,maxx)
}

if(!is.null(YLIM)){
}
else{
maxx<-max(datos[,varY],na.rm=TRUE)
minn<-min(datos[,varY],na.rm=TRUE)
YLIM<-c(minn,maxx)
}




remove_outliers <- function(x, na.rm = TRUE, ...) {
  qnt <- quantile(x, probs=c(quant1, quant2), na.rm = na.rm, ...)
  H <- 1.5 * IQR(x, na.rm = na.rm)
  y <- x
  y[x < (qnt[1] - H)] <- NA
  y[x > (qnt[2] + H)] <- NA
  y
}


if(!is.null(XLAB)) xlab<-XLAB else xlab<-varX
if(!is.null(YLAB)) ylab<-YLAB else ylab<-varY




ymax<-max(datos[,varY],na.rm=T)
ymin<-min(datos[,varY],na.rm=T)
xmax<-max(datos[,varX],na.rm=T)
xmin<-min(datos[,varX],na.rm=T)


if(!is.null(PLOT)){
plotexe<-paste("plot.default(","datos[,varY]~datos[,varX],",toString(x=PLOT), ")")
eval(parse(text=plotexe))
}
else{
plotexe<-paste("plot.default(","datos[,varY]~datos[,varX],", "type=type,", "lty=ltyL,", "lwd=lwdL,",
"xlab=xlab,", "ylab=ylab,","col=COLOR,","xlim=XLIM,","ylim=YLIM,", "cex=CEX,", "pch=PCH",")")
eval(parse(text=plotexe))
}


if(reg==TRUE){

if(model=="Linear"){

datos2<-data.frame(datos[,varY],datos[,varX])
colnames(datos2)<-c(varY,varX)
fo<-paste(names(datos2)[1], "~", names(datos2)[2])
reg<-lm(fo,data=datos2)
res<-residuals(reg)

if(outliers==TRUE){
resOut<- remove_outliers(res)
datosOut<-data.frame(datos,resOut)
datos<-na.exclude(datosOut)
datos2<-data.frame(datos[,varY],datos[,varX])
colnames(datos2)<-c(varY,varX)
fo<-paste(names(datos2)[1], "~", names(datos2)[2])
reg<-lm(fo,data=datos2)
}

Re<-summary(reg)



cx<-seq(xmin,xmax, length.out = 100)
cy<-reg$coefficients[1]+reg$coefficients[2]*cx

lines(cx,cy,  col=COLORR, lty=lty, lwd=lwd)

res<-residuals(reg)


#Normality
Lillie<-nortest::lillie.test(res)

#Autocorrelation
DW<-lmtest::dwtest(reg)

#Homocedasticity
BreuschPagan<-lmtest::bptest(reg)


Resultados<-list(varY,"LINEAR REGRESSION",Re,"Normality", Lillie, "Autocorrelation", DW, "Homocedasticity",BreuschPagan)

print(Resultados)

if(!is.null(file)){
sink(file, append=TRUE)
print(Resultados)
sink()
}

}#Fin Linear



if(model=="Log"){

if(min(datos[,varX])>=0.01){
datos2<-data.frame(datos[,varY],log(datos[,varX]))
colnames(datos2)<-c(varY,varX)
fo<-paste(names(datos2)[1], "~", names(datos2)[2])
reg<-lm(fo,data=datos2)
res<-residuals(reg)

if(outliers==TRUE){
resOut<- remove_outliers(res)
datosOut<-data.frame(datos,resOut)
datos<-na.exclude(datosOut)

datos2<-data.frame(datos[,varY],log(datos[,varX]))
colnames(datos2)<-c(varY,varX)
fo<-paste(names(datos2)[1], "~", names(datos2)[2])
reg<-lm(fo,data=datos2)
}

Re<-summary(reg)



cx<-seq(xmin,xmax, length.out = 100)
cy<-reg$coefficients[1]+reg$coefficients[2]*log(cx)

lines(cx,cy,  col=COLORR, lty=lty, lwd=lwd)

res<-residuals(reg)

#Normality
Lillie<-nortest::lillie.test(res)

#Autocorrelation
DW<-lmtest::dwtest(reg)

#Homocedasticity
BreuschPagan<-lmtest::bptest(reg)


Resultados<-list(varY,"LOG REGRESSION",Re,"Normality", Lillie, "Autocorrelation", DW, "Homocedasticity",BreuschPagan)

print(Resultados)

if(!is.null(file)){
sink(file, append=TRUE)
print(Resultados)
sink()
}


}#Fin si el valor de X es mayor de cero
}#Fin Log


if(model=="S-curve"){

if(min(datos[,varY])>=0.01){
datos2<-data.frame(log(datos[,varY]),1/datos[,varX])
colnames(datos2)<-c(varY,varX)
fo<-paste(names(datos2)[1], "~", names(datos2)[2])
reg<-lm(fo,data=datos2)
res<-datos[,varY]-exp(reg$coefficients[1]+reg$coefficients[2]/datos[,varX])


if(outliers==TRUE){
resOut<- remove_outliers(res)
datosOut<-data.frame(datos,resOut)
datos<-na.exclude(datosOut)

datos2<-data.frame(log(datos[,varY]),1/datos[,varX])
colnames(datos2)<-c(varY,varX)
fo<-paste(names(datos2)[1], "~", names(datos2)[2])
reg<-lm(fo,data=datos2)
}

Re<-summary(reg)


cx<-seq(xmin,xmax, length.out = 100)
cy<-exp(reg$coefficients[1]+reg$coefficients[2]/cx)

lines(cx,cy,  col=COLORR, lty=lty, lwd=lwd)

res<-residuals(reg)

#Normality
Lillie<-nortest::lillie.test(res)

#Autocorrelation
DW<-lmtest::dwtest(reg)

#Homocedasticity
BreuschPagan<-lmtest::bptest(reg)


Resultados<-list(varY,"S-CURVE REGRESSION",Re,"Normality", Lillie, "Autocorrelation", DW, "Homocedasticity",BreuschPagan)

print(Resultados)

if(!is.null(file)){
sink(file, append=TRUE)
print(Resultados)
sink()
}


}#Fin si el valor de X es mayor de cero
}#Fin S-curve


if(model=="Power"){

if(min(datos[,varY])>=0.01){
if(min(datos[,varX])>=0.01){
datos2<-data.frame(log(datos[,varY]),log(datos[,varX]))
colnames(datos2)<-c(varY,varX)
fo<-paste(names(datos2)[1], "~", names(datos2)[2])
reg<-lm(fo,data=datos2)
res<-datos[,varY]-exp(reg$coefficients[1])*datos[,varX]^reg$coefficients[2]

if(outliers==TRUE){
resOut<- remove_outliers(res)
datosOut<-data.frame(datos,resOut)
datos<-na.exclude(datosOut)

datos2<-data.frame(log(datos[,varY]),log(datos[,varX]))
colnames(datos2)<-c(varY,varX)
fo<-paste(names(datos2)[1], "~", names(datos2)[2])
reg<-lm(fo,data=datos2)
}

Re<-summary(reg)



cx<-seq(xmin,xmax, length.out = 100)
cy<-exp(reg$coefficients[1])*cx^reg$coefficients[2]

lines(cx,cy,  col=COLORR, lty=lty, lwd=lwd)

res<-residuals(reg)

#Normality
Lillie<-nortest::lillie.test(res)

#Autocorrelation
DW<-lmtest::dwtest(reg)

#Homocedasticity
BreuschPagan<-lmtest::bptest(reg)


Resultados<-list(varY,"POWER REGRESSION",Re,"Normality", Lillie, "Autocorrelation", DW, "Homocedasticity",BreuschPagan)

print(Resultados)

if(!is.null(file)){
sink(file, append=TRUE)
print(Resultados)
sink()
}

}#mini Y
}#min X
}#Fin Power


if(model=="Exp"){

if(min(datos[,varY])>=0.01){
datos2<-data.frame(log(datos[,varY]),datos[,varX])
colnames(datos2)<-c(varY,varX)
fo<-paste(names(datos2)[1], "~", names(datos2)[2])
reg<-lm(fo,data=datos2)
res<-datos[,varY]-exp(reg$coefficients[1])*exp(datos[,varX]*reg$coefficients[2])


if(outliers==TRUE){
resOut<- remove_outliers(res)
datosOut<-data.frame(datos,resOut)
datos<-na.exclude(datosOut)

datos2<-data.frame(log(datos[,varY]),datos[,varX])
colnames(datos2)<-c(varY,varX)
fo<-paste(names(datos2)[1], "~", names(datos2)[2])
reg<-lm(fo,data=datos2)
}

Re<-summary(reg)


cx<-seq(xmin,xmax, length.out = 100)
cy<-exp(reg$coefficients[1])*exp(cx*reg$coefficients[2])

lines(cx,cy,  col=COLORR, lty=lty, lwd=lwd)

res<-residuals(reg)

#Normality
Lillie<-nortest::lillie.test(res)

#Autocorrelation
DW<-lmtest::dwtest(reg)

#Homocedasticity
BreuschPagan<-lmtest::bptest(reg)


Resultados<-list(varY,"EXPONENTIAL REGRESSION",Re,"Normality", Lillie, "Autocorrelation", DW, "Homocedasticity",BreuschPagan)

print(Resultados)

if(!is.null(file)){
sink(file, append=TRUE)
print(Resultados)
sink()
}

}#Fin si el valor de X es mayor de cero
}#Fin Exp


if(model=="Quadratic"){

datos2<-data.frame(datos[,varY],datos[,varX],datos[,varX]^2)
colnames(datos2)<-c(varY,varX,paste(varX,"2",sep=""))
fo<-paste(names(datos2)[1], "~", names(datos2)[2],"+",names(datos2)[3])
reg<-lm(fo,data=datos2)
res<-residuals(reg)

if(outliers==TRUE){
resOut<- remove_outliers(res)
datosOut<-data.frame(datos,resOut)
datos<-na.exclude(datosOut)

datos2<-data.frame(datos[,varY],datos[,varX],datos[,varX]^2)
colnames(datos2)<-c(varY,varX,paste(varX,"2",sep=""))
fo<-paste(names(datos2)[1], "~", names(datos2)[2],"+",names(datos2)[3])
reg<-lm(fo,data=datos2)
}

Re<-summary(reg)



cx<-seq(xmin,xmax, length.out = 100)
cy<-reg$coefficients[1]+reg$coefficients[2]*cx+reg$coefficients[3]*cx^2

lines(cx,cy,  col=COLORR, lty=lty, lwd=lwd)

res<-residuals(reg)

#Normality
Lillie<-nortest::lillie.test(res)

#Autocorrelation
DW<-lmtest::dwtest(reg)

#Homocedasticity
BreuschPagan<-lmtest::bptest(reg)


Resultados<-list(varY,"QUADRATIC REGRESSION",Re,"Normality", Lillie, "Autocorrelation", DW, "Homocedasticity",BreuschPagan)

print(Resultados)

if(!is.null(file)){
sink(file, append=TRUE)
print(Resultados)
sink()
}

}#Fin Quadratic

if(model=="Cubic"){

datos2<-data.frame(datos[,varY],datos[,varX],datos[,varX]^2,datos[,varX]^3)
colnames(datos2)<-c(varY,varX,paste(varX,"2",sep=""),paste(varX,"3",sep=""))
fo<-paste(names(datos2)[1], "~", names(datos2)[2],"+",names(datos2)[3],"+",names(datos2)[4])
reg<-lm(fo,data=datos2)
res<-residuals(reg)

if(outliers==TRUE){
resOut<- remove_outliers(res)
datosOut<-data.frame(datos,resOut)
datos<-na.exclude(datosOut)

datos2<-data.frame(datos[,varY],datos[,varX],datos[,varX]^2,datos[,varX]^3)
colnames(datos2)<-c(varY,varX,paste(varX,"2",sep=""),paste(varX,"3",sep=""))
fo<-paste(names(datos2)[1], "~", names(datos2)[2],"+",names(datos2)[3],"+",names(datos2)[4])
reg<-lm(fo,data=datos2)
}

Re<-summary(reg)


cx<-seq(xmin,xmax, length.out = 100)
cy<-reg$coefficients[1]+reg$coefficients[2]*cx+reg$coefficients[3]*cx^2+reg$coefficients[4]*cx^3

lines(cx,cy,  col=COLORR, lty=lty, lwd=lwd)

res<-residuals(reg)

#Normality
Lillie<-nortest::lillie.test(res)

#Autocorrelation
DW<-lmtest::dwtest(reg)

#Homocedasticity
BreuschPagan<-lmtest::bptest(reg)


Resultados<-list(varY,"CUBIC REGRESSION",Re,"Normality", Lillie, "Autocorrelation", DW, "Homocedasticity",BreuschPagan)

print(Resultados)

if(!is.null(file)){
sink(file, append=TRUE)
print(Resultados)
sink()
}

}#Fin Cubic



if(model=="Inverse"){

if(is.na(match(0,datos[,varX]))){
datos2<-data.frame(datos[,varY],1/datos[,varX])
colnames(datos2)<-c(varY,varX)
fo<-paste(names(datos2)[1], "~", names(datos2)[2])
reg<-lm(fo,data=datos2)
res<-residuals(reg)

if(outliers==TRUE){
resOut<- remove_outliers(res)
datosOut<-data.frame(datos,resOut)
datos<-na.exclude(datosOut)

datos2<-data.frame(datos[,varY],1/datos[,varX])
colnames(datos2)<-c(varY,varX)
fo<-paste(names(datos2)[1], "~", names(datos2)[2])
reg<-lm(fo,data=datos2)
}

Re<-summary(reg)


cx<-seq(xmin,xmax, length.out = 100)
cy<-reg$coefficients[1]+reg$coefficients[2]*1/cx

lines(cx,cy,  col=COLORR, lty=lty, lwd=lwd)

res<-residuals(reg)

#Normality
Lillie<-nortest::lillie.test(res)

#Autocorrelation
DW<-lmtest::dwtest(reg)

#Homocedasticity
BreuschPagan<-lmtest::bptest(reg)


Resultados<-list(varY,"INVERSE REGRESSION",Re,"Normality", Lillie, "Autocorrelation", DW, "Homocedasticity",BreuschPagan)

print(Resultados)

if(!is.null(file)){
sink(file, append=TRUE)
print(Resultados)
sink()
}

}#Fin si el valor de X es mayor de cero
}#Fin Inverse



}#Fin regresion





if(!is.null(textlabel)){
if(!is.null(label)){
tx<-paste("text(","x=datos[,varX],", "y=datos[,varY],", "labels=datos[,textlabel],", toString(x=label), ")")
eval(parse(text=tx))
}
else{
tx<-paste("text(","x=datos[,varX],", "y=datos[,varY],", "labels=datos[,textlabel],", "pos=3", ")")
eval(parse(text=tx))
}
}


}


##################
##################
##################End function AA


variables<-c(varY,varY1,varY2,varY3)
nvar<-length(variables)

if(is.null(PCH)){
PCH<-seq(15,15+nvar,1)
}

if(is.null(type)){
type<-rep("b",nvar)
}

if(is.null(model)){
model<-rep("Linear",nvar)
}


if(is.null(lty)){
lty<-rep(1,nvar)
}

if(is.null(ltyL)){
ltyL<-rep(1,nvar)
}


if(is.null(COLOR)){
COLOR<-rainbow(nvar)
}

if(is.null(COLORR)){
COLORR<-COLOR
}

if(ResetPAR==TRUE){
#Resetear par() a las opciones por defecto
resetPar <- function() {
    dev.new()
    op <- par(no.readonly = TRUE)
    dev.off()
    op
}
par(resetPar()) }
else{
}

mar<-c(5,5,3,2)

if(!is.null(varY1)){
mar<-MAR1
}

if(!is.null(varY2)){
mar<-MAR2
}

if(!is.null(varY3)){
mar<-MAR3
}


if(!is.null(PAR)){
parexe<-paste("par(new,",toString(x=PAR), ")")
eval(parse(text=parexe))
}
else{

par(font.lab=FONTLAB, mar=mar,cex.lab=CEXLAB)
}

if(reg==TRUE & file.exists(file)){
file.remove(file)
}



AA(data=data, varY=varY,  varX=varX, textlabel=textlabelY, type=type[1],
label=label, reg=reg, model=model[1], outliers=outliers, quant1=quant1,
quant2 = quant2,   XLAB=XLAB, YLAB=YLAB,  XLIM=XLIM,
YLIM=YLIM,  CEX=CEX,
COLOR=COLOR[1], COLORR=COLORR[1], PCH=PCH[1], lty=lty[1],  ltyL=ltyL[1], lwd=lwd, lwdL=lwdL,  
PLOT=NULL, file=file)

if(!is.null(LEGEND)){
legendexe<-paste("legend(",toString(x=LEGEND), ")")
eval(parse(text=legendexe))
}
else{
legendexe<-paste("legend(","x='topleft',","legend=variables,","bty='n',", "lty=ltyL,", "col=COLOR,",
"pch=PCH", ")")
eval(parse(text=legendexe))
}

if(!is.null(MTEXT)){
mtextexe<-paste("mtext(",toString(x=MTEXT), ")")
eval(parse(text=mtextexe))
}
else{
}

if(!is.null(TEXT)){
textexe<-paste("text(",toString(x=TEXT), ")")
eval(parse(text=textexe))
}
else{
}



if(!is.null(varY1)){
par(new=TRUE)
PLOT = c("type = type" , "xlab = xlab" , "ylab = ylab" , "xlim=XLIM", "ylim=YLIM1", "cex=CEX", "axes = FALSE" , "col = COLOR" , "lty = ltyL" , "pch = PCH" , "lwd = lwdL")

AA(data=data, varY=varY1,  varX=varX, textlabel=textlabelY1, type=type[2],
label=label, reg=reg, model=model[2], outliers=outliers, quant1=quant1,
quant2 = quant2,  PAR=PAR, XLAB="", YLAB="", XLIM=XLIM,
YLIM=YLIM, CEX=CEX,
COLOR=COLOR[2], COLORR=COLORR[2], PCH=PCH[2], lty=lty[2],  ltyL=ltyL[2], lwd=lwd, lwdL=lwdL,  
PLOT=PLOT,  file=file)

if(!is.null(YLAB1)) ylab=YLAB1 else ylab=varY1


axis(4)
mtext(ylab,4,line=2.5, font=FONTLAB, cex=CEXLAB)
}

if(!is.null(varY2)){
par(new=TRUE)
PLOT = c("type = type" , "xlab = xlab" , "ylab = ylab" , "xlim=XLIM", "ylim=YLIM2", "cex=CEX", "axes = FALSE" , "col = COLOR" , "lty = ltyL" , "pch = PCH" , "lwd = lwdL")

AA(data=data, varY=varY2,  varX=varX, textlabel=textlabelY2, type=type[3],
label=label, reg=reg, model=model[3], outliers=outliers, quant1=quant1,
quant2 = quant2,  PAR=PAR, XLAB="", YLAB="", XLIM=XLIM,
YLIM=YLIM, CEX=CEX,
COLOR=COLOR[3], COLORR=COLORR[3], PCH=PCH[3], lty=lty[3],  ltyL=ltyL[3], lwd=lwd, lwdL=lwdL, 
PLOT=PLOT,  file=file)

if(!is.null(YLAB2)) ylab=YLAB2 else ylab=varY2

axis(4, line=4)
mtext(ylab,4,line=6.5, font=FONTLAB, cex=CEXLAB)
}


if(!is.null(varY3)){
par(new=TRUE)
PLOT = c("type = type" , "xlab = xlab" , "ylab = ylab" , "xlim=XLIM", "ylim=YLIM3", "cex=CEX", "axes = FALSE" , "col = COLOR" , "lty = ltyL" , "pch = PCH" , "lwd = lwdL")

AA(data=data, varY=varY3,  varX=varX, textlabel=textlabelY3, type=type[4], 
label=label, reg=reg, model=model[4], outliers=outliers, quant1=quant1,
quant2 = quant2,   PAR=PAR, XLAB="", YLAB="", XLIM=XLIM,
YLIM=YLIM, CEX=CEX,
COLOR=COLOR[4], COLORR=COLORR[4], PCH=PCH[4], lty=lty[4],  ltyL=ltyL[4], lwd=lwd, lwdL=lwdL, 
PLOT=PLOT, file=file)

if(!is.null(YLAB3)) ylab=YLAB3 else ylab=varY3

axis(4, line=8)
mtext(ylab,4,line=10.5, font=FONTLAB, cex=CEXLAB)
}



}
