F86<-function(data, varY,  varX,  rylim, rxlim, ResetPAR=TRUE, PAR=NULL, XLAB=NULL, YLAB=NULL,
XLIM=NULL, YLIM=NULL, MAIN=NULL, titlepos =NA, COLOR="tomato",  PCH=16, ZOOM=NULL,  MTEXT= NULL, TEXT=NULL){

datos<-data

datosT<-data.frame(subset(datos, select=varY), subset(datos, select=varX))


datos<-na.exclude(datosT)

if(ResetPAR==TRUE){
#Resetear par() a las opciones por defecto
resetPar <- function() {
    dev.new()
    op <- par(no.readonly = TRUE)
    dev.off()
    op
}
par(resetPar()) }
else{
}


if(!is.null(XLAB)) xlab<-XLAB else xlab<-varX
if(!is.null(YLAB)) ylab<-YLAB else ylab<-varY

if(!is.null(PAR)){
parexe<-paste("par(new,",toString(x=PAR), ")")
eval(parse(text=parexe))
}
else{
par(font.lab=2, mar=c(5,5,3,2),cex.lab=1.5)
}


if(!is.null(ZOOM)){
plotexe<-paste("plotrix::zoomInPlot(","x=datos[,varX],", "y=datos[,varY],", toString(x=ZOOM), ")")
eval(parse(text=plotexe))
}
else{
plotexe<-paste("plotrix::zoomInPlot(","x=datos[,varX],", "y=datos[,varY],", 
"xlim = XLIM,",  "ylim = YLIM,",  "rxlim = rxlim,",  "rylim = rylim,",  "xlab = xlab,",  "ylab = ylab,",
"zoomtitle = MAIN,",  "titlepos = titlepos,", "pch = PCH,", "col = COLOR", ")")
eval(parse(text=plotexe))
}

if(!is.null(MTEXT)){
mtextexe<-paste("mtext(",toString(x=MTEXT), ")")
eval(parse(text=mtextexe))
}
else{
}

if(!is.null(TEXT)){
textexe<-paste("text(",toString(x=TEXT), ")")
eval(parse(text=textexe))
}
else{
}


}