\name{F20}
\alias{F20}
\encoding{latin1}
\title{DOT HISTOGRAM WITH ONE OR SEVERAL VARIABLES}
\description{It performs a dot histogram with one or several variables.}
\usage{
F20(data, var, ResetPAR=TRUE, PAR=NULL, YLAB=NULL, XLIM=NULL,
COLOR=NULL, PCH=16, LEGEND=NULL, AXIS=NULL, MTEXT= NULL, TEXT=NULL)
}
\arguments{
  \item{data}{Data file.}
  \item{var}{Variables.}
  \item{ResetPAR}{If it is FALSE, the default condition of the function \link[StatR]{PAR} is not placed and maintained those defined by the user in previous graphics.}
  \item{PAR}{It accesses the function \link[StatR]{PAR} that allows to modify many different aspects of the graph.}
  \item{YLAB}{Legend of the Y axis.}
  \item{XLIM}{Vector with the limits of the X axis.}
  \item{COLOR}{Color of the dots.}
  \item{PCH}{Graphic symbol (see the description of the same argument in the function \link{F1}).}
  \item{LEGEND}{It allows to add a legend to the graph.}
  \item{AXIS}{It allows to add axes to the graph.}
  \item{MTEXT}{It allows to add text on the margins of the graph.}
  \item{TEXT}{It allows to add text in any area of the inner part of the graph.}
}
\value{A dot histogram for one or several variables is obtained.}  
\details{
\strong{FUNCTIONS}

The dot histogram is performed with the function dotplot of the package epicalc (Chongsuvivatwong, 2012).

\strong{EXAMPLES}

For the examples, morphometric data of three families of freshwater fishes, as the distance from the origin of the dorsal fin to the origin of the anal fin (M13), the length of the dorsal fin base (M12), body height (M11), etc., are used. For details see Guisande et al. (2010).

A dot histogram is depicted for three variables: M11, M15 and M12.
\tabular{c}{
\figure{F55}{options: width=3.6in}
}
}
\references{
Guisande, C., Manjarrs-Hernndez, A., Pelayo-Villamil, P., Granado-Lorencio, C., Riveiro, I., Acua, A., Prieto-Piraquive, E., Janeiro, E., Matas, J.M., Patti, C., Patti, B., Mazzola, S., Jimnez, S., Duque, V. & Salmern, F. (2010) IPez: An expert system for the taxonomic identification of fishes based on machine learning techniques. \emph{Fisheries Research}, 102, 240-247.

Chongsuvivatwong, V. (2012) Epidemiological calculator. R package version 2.15.1.0. Available at: \url{https://cran.r-project.org/src/contrib/Archive/epicalc/}.
}
\examples{
\dontrun{

data(Z8)

F20(data=Z8, var=c("M11","M15","M16"))
}
}
\keyword{F20}
