\name{F42}
\alias{F42}
\encoding{latin1}
\title{3D DYMANIC SCATTER PLOTS}
\description{It performs 3D dynamic scatter plots.}
\usage{
F42(data, varZ,  varY, varX, PLOT3D=NULL, CEX=2, COLOR="red", ZLAB=NULL,
YLAB=NULL, XLAB=NULL, ZLIM=NULL, YLIM=NULL, XLIM=NULL)
}
\arguments{
  \item{data}{Data file.}
  \item{varZ}{Variable Z.}
  \item{varY}{Variable Y.}
  \item{varX}{Variable X.}
  \item{PLOT3D}{It allows to modify the plot using the function plot3d.}
  \item{CEX}{Size of the symbols.}
  \item{COLOR}{Color of the symbols.}
  \item{ZLAB}{Legend of the Z axis.}
  \item{YLAB}{Legend of the Y axis.}
  \item{XLAB}{Legend of the X axis.}
  \item{ZLIM}{Vector with the limits of the Z axis.}
  \item{YLIM}{Vector with the limits of the Y axis.}
  \item{XLIM}{Vector with the limits of the X axis.}
}
\value{3D dynamic scatter plot is obtained.}  
\details{
\strong{FUNCTIONS}

The 3D plot was performed with the function plot3d of the package rgl (Adler et al., 2015).

\strong{EXAMPLES}

The data are the percentages of three amino acids in different species of rotifers obtained from ponds of Doana National Park (Spain) (Guisande et al., 2008).
\tabular{c}{
\figure{F93}{options: width=2.5in}
}
}
\references{
Adler, D., Murdoch, D. and others (2015) 3D Visualization Using OpenGL. R package version 0.95.1247. Available at: \url{https://CRAN.R-project.org/package=rgl}.

Guisande, C., Granado-Lorencio, C, Toja, J. & Len, D. (2008 Identification of the main factors in structuring rotifer community assemblages in ponds of Doana National Park using the amino acid composition of the species. \emph{Limnetica}, 27: 273-284.
}
\examples{
\dontrun{

data(Z17)

F42(data=Z17, varZ="Aspartate", varY="Glutamate", varX="Serine")
}
}
\keyword{F42}
