\name{F53}
\alias{F53}
\encoding{latin1}
\title{BUBBLE CHART}
\description{It performs a bubble chart in which a variable defines the size of the bubble and other variable the color gradient of the bubbles.}
\usage{
F53(data, varY, varX, varSize=NULL, varColor=NULL, palette= "heat.colors",
size=c(1,5), legSpos="topleft", orientation="vertical", digitsS=0, digitsC=0, 
ncolor=10, transparency=1, ResetPAR=TRUE, PAR=NULL, PLOT=NULL, POINTS=NULL,
COLEGEND=NULL, XLAB=NULL, YLAB=NULL, XLIM=NULL, YLIM=NULL, LEGENDS=NULL,
MTEXT= NULL, TEXT=NULL, AXIS=NULL)
}
\arguments{
  \item{data}{Data file.}
  \item{varY}{Variable Y.}
  \item{varX}{Variable X.}
  \item{varSize}{This variable defines the size of the bubble.}
  \item{varColor}{This variable defines the color gradient of the bubbles.}
  \item{palette}{The color gradient may be one of these palettes: "heat.colors", "terrain.colors", "gray.colors", "topo.colors" or "cm.colors".}
  \item{size}{Range of size of the bubbles. Two values: minimum and maximum size.}
  \item{legSpos}{Position of the size legend: "topleft", "topright", "bottomleft" or "bottomright".}
  \item{orientation}{Orientation of the size legend: "vertical" or "horizontal"}
  \item{digitsS}{Number of digits of the bubble size legend.}
  \item{digitsC}{Number of digits of the color legend.}
  \item{ncolor}{Number of breakpoints of the color legend.}
  \item{transparency}{Transparency of the color gradient, from 0 to 1.}
  \item{ResetPAR}{If it is FALSE, the default condition of the function \link[StatR]{PAR} is not placed and maintained those defined by the user in previous graphics.}
  \item{PAR}{It accesses the function \link[StatR]{PAR} that allows to modify many different aspects of the graph.}
  \item{PLOT}{It allows to modify the plot with the function \link[graphics]{plot.default}.}
  \item{POINTS}{It allows to modify the points of the plot with the function \link[graphics]{points}.}
  \item{COLEGEND}{It allows to modify the color legend with the function \link[plotrix]{color.legend}.}
  \item{XLAB}{Legend of the X axis.}
  \item{YLAB}{Legend of the Y axis.}
  \item{XLIM}{Vector with the limits of the X axis.}
  \item{YLIM}{Vector with the limits of the Y axis.}
  \item{LEGENDS}{It allows to modify the legend of the bubble size.}
  \item{MTEXT}{It allows to add text on the margins of the graph.}
  \item{TEXT}{It allows to add text in any area of the inner part of the graph.}
  \item{AXIS}{It allows to add axes to the graph.}
}
\value{A bubble chart is obtained.}  
\details{
\strong{FUNCTIONS}

The plot is performed with the function \link[graphics]{plot.default} of base graphics package. The color legend is performed with the function \link[plotrix]{color.legend} of the package plotrix (Lemon et al., 2015). 

\strong{EXAMPLES}

The examples use the records of the freshwater fish species \emph{Perca fluviatilis} in diferent geographic coordinates, and the temperature and altitude.

\strong{Example 1} The size of the bubble is according to the number of records for each latitude and longitude. The position and orientation of the size legend is changed with the arguments \emph{legSpos="bottomright"} and \emph{orientation="horizontal"}, respectively.
\tabular{c}{
\figure{F115}{options: width=3.8in}
}
\strong{Example 2} The color gradient is according to the temperature for each latitude and longitude. 
\tabular{c}{
\figure{F116}{options: width=3.8in}
}
\strong{Example 3} Both bubble size and color gradient are used.
\tabular{c}{
\figure{F117}{options: width=3.8in}
}
}
\references{
Lemon, J., Bolker, B., Oom, S., Klein, E., Rowlingson, B., Wickham, H., Tyagi, A., Eterradossi, O., Grothendieck, G., Toews, M., Kane, J., Turner, R., Witthoft, C., Stander, J., Petzoldt, T., Duursma, R., Biancotto, E., Levy, O., Dutang, C., Solymos, P., Engelmann, R., Hecker, M., Steinbeck, F., Borchers, H., Singmann, H., Toal, T. & Ogle, D. (2015) Various plotting functions. R package version 3.5-11. Available at: \url{https://CRAN.R-project.org/package=plotrix}.
}
\examples{
\dontrun{

#Example 1

data(Z19)

F53(data=Z19, varY="Latitude", varX="Longitude", varSize="Records",
legSpos="bottomright", orientation="horizontal")

#Example 2

data(Z19)

F53(data=Z19, varY="Latitude", varX="Longitude", varColor="Temperature")

#Example 3

data(Z19)

F53(data=Z19, varY="Latitude", varX="Longitude", varSize="Records",
varColor="Temperature")
}
}
\keyword{F53}
