\name{F55}
\alias{F55}
\encoding{latin1}
\title{CONDITIONAL DENSITY PLOTS}
\description{It performs a conditional density plot describing how the distribution of a qualitative variable varies over a quantitative variable.}
\usage{
F55(data, varQuali, varQuanti, OrderCat=NULL, LabelCat=NULL, font.lab=2, cex.lab=14,
ylab_tol=0.05, bw="nrd0", n=512, main="", margins=c(5.1, 4.1, 4.1, 3.1),
XLAB=NULL, YLAB=NULL, XLIM=NULL, COLOR=NULL)
}
\arguments{
  \item{data}{Data file.}
  \item{varQuali}{Qualitative variable.}
  \item{varQuanti}{Quantitative variable.}
  \item{OrderCat}{It allows to specify a vector with the order in which the categories of the variable \emph{varQuali} are shown.}
  \item{LabelCat}{It allows to specify a vector with the names of the categories of the variable \emph{varQuali}.}
  \item{font.lab}{Font of the legend of the axes.}
  \item{cex.lab}{Size of the legend of the axes.}
  \item{ylab_tol}{Convenience tolerance parameter for y-axis annotation. If the distance between two labels drops under this threshold, they are plotted equidistantly.}
  \item{bw}{The smoothing bandwidth to be used. For details see \link[stats]{bandwidth}.}
  \item{n}{The number of equally spaced points at which the density is to be estimated.}
  \item{main}{Main title.}
  \item{margins}{Margins of the plot.}
  \item{XLAB}{Legend of the X axis.}
  \item{YLAB}{Legend of the Y axis.}
  \item{XLIM}{Vector with the limits of the X axis.}
  \item{COLOR}{Vector with the color of the categories or just one color for all categories.}
}
\value{A conditional density plot is obtained.}  
\details{
\strong{FUNCTIONS}

The graph is performed with the function cd_plot of the package vcd (Meyer et al., 2006; 2008; 2015). For further details see Guisande & Vammonde (2012).

\strong{EXAMPLES}

Smoking behaviour of men and women who smoke in different work centres.

The figure shows the relative proportion the of the persons interviewed in the four work centres according to their age.
\tabular{c}{
\figure{F123}{options: width=4.5in}
}
}
\references{
Guisande, C. & Vaamonde, A. (2012) \emph{Grficos estadsticos y mapas con R}. Ediciones Daz de Santos, Madrid, 367 pp.

Meyer, D., Zeileis, A. & Hornik, K. (2006) The strucplot framework: Visualizing multiway contingency tables with vcd. \emph{Journal of Statistical Software}, 17: 1-48.

Meyer, D., Zeileis, A. &Hornik, K. (2008) Visualizing contingency tables. In Chun-Houh Chen, Wolfang Hrdle, and Antony Unwin, editors, Handbook of Data Visualization, Springer Handbooks of Computational Statistics, pages 589-616. Springer-Verlag, New York. ISBN 978-3-540-33036-3.

Meyer, D., Zeileis, A. & Hornik, K. (2015) Visualizing Categorical Data. R package version 1.4-1. Available at: \url{https://CRAN.R-project.org/package=vcd}.
}
\examples{
\dontrun{

data(Z20)

F55(data=Z20, varQuali="Workplace", varQuanti="Age")
}
}
\keyword{F55}
