\name{F61}
\alias{F61}
\encoding{latin1}
\title{SIMPLE MEAN WITH ERROR BARS SCATTER PLOTS, WITH TEXT LABELS AND REGRESSION, AND WITH MARGINAL HISTOGRAMS}
\description{It performs a simple mean with error bars scatter plot for variable X quantitativ, with text labels and a  regression model, and with marginal histograms.}
\usage{
F61(data, varY,  varX, Factor, method="mean", dev="sd", barY=TRUE,
barX=FALSE, textlabel=FALSE, label=NULL,  MAR1=c(5,5,1,1), MAR2=c(2,5,1,0),
MAR3=c(5,1.5,0,1), reg=FALSE, model="Linear", outliers=FALSE, quant1=0.05,
quant2 = 0.95, ResetPAR=FALSE, PAR=NULL, XLAB=NULL, YLAB=NULL, XLIM=NULL,
YLIM=NULL,  COLOR="black", COLORI="black", COLORR="red", PCH=16, lty=3,
lwd=2.5, R2.pos="topleft", PLOT=NULL, LEGEND=NULL, AXIS=NULL, MTEXT= NULL,
TEXT=NULL, file1="Output.txt", file2="Average and error bars.csv", na="NA",
dec=",", row.names=FALSE, HIST=NULL, HISTh=NULL, breaks=20, COLORl=NULL,
COLORb="grey", MTEXTh1= NULL, TEXTh1=NULL, MTEXTh2= NULL, TEXTh2=NULL)
}
\arguments{
  \item{data}{Data file.}
  \item{varY}{Dependent variable.}
  \item{varX}{Quantitative independent variable.}
  \item{Factor}{Variable for the estimation of the average and error bars for each category of the variable. It is not possible to include variables with any of the categories with a single data, so if necessary several data for each category.}
  \item{method}{The average of each category of the grouped variable \emph{Factor} is estimated with the "mean" or the "median".}
  \item{dev}{The error bars may be estimated using the standard deviation ("sd") or the standard error ("se").}
  \item{barY}{If it is TRUE the bar error of the variable Y is depicted.}
  \item{barX}{If it is TRUE the bar error of the variable X is depicted.}
  \item{textlabel}{If TRUE the text labels of the categories of the variable \emph{Factor} are shown.}
  \item{label}{It allows to specify the characteristics of the text labels with the function \link[graphics]{text}.}
  \item{MAR1}{A numeric vector with the format c(down, left, up, right) that defines the lines of the margins of the scatter plot.}
  \item{MAR2}{A numeric vector with the format c(down, left, up, right) that defines the lines of the margins of the upper histogram.}
  \item{MAR3}{A numeric vector with the format c(down, left, up, right) that defines the lines of the margins of the right side histogram.}
  \item{reg}{If it is TRUE a regression model is performed.}
  \item{model}{One regression model can be selected: "Linear" , "Log", "S-curve", "Power", "Exp", "Quadratic", "Cubic", "Inverse".  It is not considered the model in those cases in which there is the logarithm that apply to any of the variables, if any value of the variable, which applies the logarithm, is zero or negative. The inverse model is not calculated if any value of the independent variable is zero.}
\item{outliers}{If it is TRUE, the outliers are removed using the selected regression model.}
  \item{quant1}{Quantile of the lower end to the elimination of outliers.}
  \item{quant2}{Quantile of the upper end to the elimination of outliers.}
  \item{ResetPAR}{If it is FALSE, the default condition of the function \link[StatR]{PAR} is not placed and maintained those defined by the user in previous graphics.}
  \item{PAR}{It accesses the function \link[StatR]{PAR} that allows to modify many different aspects of the graph.}
  \item{XLAB}{Legend of the X axis in the scatter plot.}
  \item{YLAB}{Legend of the Y axis in the scatter plot.}
  \item{XLIM}{Vector with the limits of the X axis in the scatter plot.}
  \item{YLIM}{Vector with the limits of the Y axis in the scatter plot.}
  \item{COLOR}{Color of the symbols in the scatter plot.}
  \item{COLORI}{Color of the error bars in the scatter plot.}
  \item{COLORR}{Color of the line of the regression model in the scatter plot.}
  \item{PCH}{Graphic symbol (see the description of the same argument in the function \link{F1}).}
  \item{lty}{Type of the regression line (see the description of the same argument in the function \link{F1}).}
  \item{lwd}{Line width of the regression line relative to the default (default=1), so 2 is twice as wide.}
  \item{R2.pos}{If it is not NULL, with this argument is possible to specify the position of the \eqn{r^2} of the regression in the scatter plot.}
  \item{PLOT}{It allows to specify the characteristics of the function \link[graphics]{plot.default}.}
  \item{LEGEND}{It allows to include a legend to the graph.}
  \item{AXIS}{It allows to add axes to the graph.}
  \item{MTEXT}{It allows to add text on the margins of the graph.}
  \item{TEXT}{It allows to add text in any area of the inner part of the graph.}
  \item{file1}{TXT FILE. If the argument \emph{reg=TRUE} a TXT file is saved with the information of the regression.}
  \item{file2}{CSV FILE. File name with the mean, median, standard error and standard deviation for each category of the variable \emph{Factor}.}
  \item{na}{CSV FILES. Text that is used in the cells without data.}
  \item{dec}{CSV FILES. It defines if the comma "," is used as decimal separator or the dot ".".}
  \item{row.names}{CSV FILES. Logical value that defines if identifiers are put in rows or a vector with a text for each of the rows.}
  \item{HIST}{It allows to specify the characteristics of the upper histogram with the function \link[graphics]{hist}.}
  \item{HISTh}{It allows to specify the characteristics of the right side histogram with the function \link[graphics]{barplot}.}
  \item{breaks}{Number of intervals.}
  \item{COLORl}{Color of the borders. It must be as many as different variables.}
  \item{COLORb}{Color of ther bars. It must be as many as different variables.}
  \item{MTEXTh1}{It allows to add text on the margins of the upper side histrogram.}
  \item{TEXTh1}{It allows to add text in any area of the inner part of the upper side histrogram.}
  \item{MTEXTh2}{It allows to add text on the margins of the right side histogram.}
  \item{TEXTh2}{It allows to add text in any area of the inner part of the right side histogram.}
}
\value{A simple scatter plot with mean error bars, with or without linear regression and with or without text labels, and with marginal histrograms is obtained. A CVS file with the mean, median, standard error and standard deviation for each category of the variable \emph{Factor} is also obtained.}  
\details{

The equations of all regression models are in the section \emph{details} of the function \link[StatR]{XI1} of the package StatR.

\strong{FUNCTIONS}

All the functions used are the same than those described in function \link{F22}, and the histograms are performed with the functions \link[graphics]{hist} and \link[graphics]{barplot} of base graphics package.

\strong{EXAMPLES}

For the examples, morphometric data of several fish species of Characiforms are used. For details see Guisande et al. (2010). It is shown the relationship between M11 and M13 for all genera.

\strong{Example 1} Relationship between the mean values of M13 and M11 for each genera with the standard deviation of the M11.
\tabular{c}{
\figure{F135}{options: width=3.4in}
}
\strong{Example 2} As in the example 1 but adding the text labels of the genera with the argument \emph{textlabel=TRUE}.
\tabular{c}{
\figure{F136}{options: width=3.4in}
}
\strong{Example 3} As in the example 1 but a linear regression line is added with the argument \emph{reg=TRUE} and also is shown the standard deviation on the variable M13 with the argument \emph{barX=TRUE}.
\tabular{c}{
\figure{F137}{options: width=3.4in}
}
For the explanation of the regression model shown in the TXT file, see function \link{F22}.
}
\references{
Durbin, J. & Watson G.S. (1951) Testing for serial correlation in least squares regression. \emph{Biometrika}, \strong{38}, 159-171.

Gross, J. (2013) Tests for Normality. R package version 1.0-2. Available at: \url{https://CRAN.R-project.org/package=nortest}.

Guisande, C., Manjarrs-Hernndez, A., Pelayo-Villamil, P., Granado-Lorencio, C., Riveiro, I., Acua, A., Prieto-Piraquive, E., Janeiro, E., Matas, J.M., Patti, C., Patti, B., Mazzola, S., Jimnez, S., Duque, V. & Salmern, F. (2010) IPez: An expert system for the taxonomic identification of fishes based on machine learning techniques. \emph{Fisheries Research}, 102, 240-247.

Hothorn, T. et al., (2013) Testing Linear Regression Models. R package version 0.9-33. Available at: \url{https://CRAN.R-project.org/package=lmtest}.
}
\examples{
\dontrun{

#Example 1

data(Z1)

F61(data=Z1, varY="M11", varX="M13", Factor="Genus")

#Example 2

F61(data=Z1, varY="M11", varX="M13", Factor="Genus", textlabel=TRUE, XLIM=c(0.2,0.8))

#Example 3

F61(data=Z1, varY="M11", varX="M13", Factor="Genus", barX=TRUE, reg=TRUE)
}
}
\keyword{F61}
