\name{F64}
\alias{F64}
\encoding{latin1}
\title{SIMPLE SCATTER PLOT FOR LARGE DATASETS}
\description{It performs a simple scatter plot for large datasets, where the colors encode the density of the points in the scatter plot.}
\usage{
F64(data, varY, varX, IPLOT=NULL, pixs=3, MAX="zmax", ResetPAR=TRUE, PAR=NULL, 
XLAB=NULL, YLAB=NULL, COLOR=IDPcolorRamp, MTEXT= NULL, TEXT=NULL)
}
\arguments{
  \item{data}{Data file.}
  \item{varY}{Dependent variable.}
  \item{varX}{Quantitative independent variable.}
  \item{IPLOT}{It allows to specify the characteristics of the plot with the function \link[IDPmisc]{iplot}.}
  \item{pixs}{Pixelsize in mm.}
  \item{MAX}{When NULL, the density in the scatter plot is encoded from 0 to maximum number of counts per pixel observed. When "zmax", the color legend ranges from the minimum to the maximum number of counts per pixel. It may be also numeric indicating the maximum of the color legend.}
  \item{ResetPAR}{If it is FALSE, the default condition of the function \link[StatR]{PAR} is not placed and maintained those defined by the user in previous graphics.}
  \item{PAR}{It accesses the function \link[StatR]{PAR} that allows to modify many different aspects of the graph.}
  \item{XLAB}{Legend of the X axis in the scatter plot.}
  \item{YLAB}{Legend of the Y axis in the scatter plot.}
  \item{COLOR}{Color ramp to encode the number of counts within a pixel.}
  \item{MTEXT}{It allows to add text on the margins of the graph.}
  \item{TEXT}{It allows to add text in any area of the inner part of the graph.}
}
\value{A scatter plot is obtained, where the colors encode the density of the points in the scatter plot.}  
\details{
\strong{FUNCTIONS}

The scatter plot is performed with the function \link[IDPmisc]{iplot} of the package IDPmisc (Locher & Ruckstuhl, 2014). For further details see the help of the function \link[IDPmisc]{iplot} and/or Guisande & Vammonde (2012).

\strong{EXAMPLES}

For the examples, morphometric data of several fish species of Characiforms are used. For details see Guisande et al. (2010). It is shown the relationship between M11 and M13 for all genera.
\tabular{c}{
\figure{F144}{options: width=4.3in}
}
}
\references{
Guisande, C., Manjarrs-Hernndez, A., Pelayo-Villamil, P., Granado-Lorencio, C., Riveiro, I., Acua, A., Prieto-Piraquive, E., Janeiro, E., Matas, J.M., Patti, C., Patti, B., Mazzola, S., Jimnez, S., Duque, V. & Salmern, F. (2010) IPez: An expert system for the taxonomic identification of fishes based on machine learning techniques. \emph{Fisheries Research}, 102, 240-247.

Guisande, C. & Vaamonde, A. (2012) \emph{Grficos estadsticos y mapas con R}. Ediciones Daz de Santos, Madrid, 367 pp.

Locher, R. & Ruckstuhl, A. (2014) Utilities of Institute of Data Analyses and Process Design. R package version 1.1.17. Available at: \url{https://CRAN.R-project.org/package=IDPmisc}.
}
\examples{
\dontrun{

data(Z1)

F64(data=Z1, varY="M11", varX="M13")
}
}
\keyword{F64}
