\name{F69}
\alias{F69}
\encoding{latin1}
\title{TIME PLOTS}
\description{It performs time series plots.}
\usage{
F69(data, date, var, year, month, date.format="\%d/\%m/\%Y \%H:\%M",
avg.time ="default", group=FALSE,  smooth=TRUE, type = "default",
name.pol=var, SUB=NULL, MAIN=NULL, XLAB=NULL, YLAB=NULL, COLOR="brewer1",
STATISTIC=NULL, TIMEP=NULL, dec=",")
}
\arguments{
  \item{data}{Data file.}
  \item{date}{Variable with the date.}
  \item{var}{Variable(s) to be depicted.}
  \item{year}{It is possible to select one or several years in a vector.}
  \item{month}{It is possible to select one or several months in a vector.}
  \item{date.format}{The format of date: "\%d/\%m/\%Y \%H:\%M", "\%d/\%m/\%Y", "\%Y/\%m/\%d \%H:\%M", "\%Y/\%m/\%d", "\%d-\%m-\%Y \%H:\%M", "\%d-\%m-\%Y", "\%Y-\%m-\%d \%H:\%M" or "\%Y-\%m-\%d"}
  \item{avg.time}{This defines the time period to average to: "default", "sec", "min", "hour", "day", "DSTday", "week", "month", "2 month", "quarter", "year" and so on. For further details see function \link[openair]{timePlot} of the package openair (Carslaw, 2016).}
  \item{group}{It is FALSE, if more than one variable is chosen, they are plotted in separate panels with their own scaled. If it is TRUE, then they are plotted on the same plot with the same scale.}
  \item{smooth}{If it is TRUE a smooth line is applied to the data.}
  \item{type}{It determines how the data are split: "default", "weekday", "month", "season", "year" and so on.}
  \item{name.pol}{Names to be given to the variable(s).}
  \item{SUB}{Legend of the subtitle.}
  \item{MAIN}{Main title.}
  \item{XLAB}{Legend of X axis.}
  \item{YLAB}{Legend of Y axis.}
  \item{COLOR}{Colours to be used for plotting.}
  \item{STATISTIC}{The statistic to apply when aggregating the data: NULL, "mean", "max", "min", "median", "frequency", "sd", or "percentile". For further details see function \link[openair]{timePlot} of the package openair (Carslaw, 2016).}
  \item{TIMEP}{It accesses the function \link[openair]{timePlot} that allows to modify many different aspects of the plot.}
  \item{dec}{It defines if the comma "," is used as decimal separator or the dot ".".}
}
\value{Time series plots are depicted.}  
\details{
\strong{FUNCTIONS}

The plot is performed with the function \link[openair]{timePlot} of the package openair (Carslaw & Ropkins, 2012; 2016).

\strong{EXAMPLES}

For the examples, hourly data of air pollutants, wind speed and wind direction in Santiago de Compostela (Spain) from 1/11/2015 to 31/12/2015 are used. The data were obtained from \url{http://www.meteogalicia.es/web/index.action}.

\strong{Example 1}. Hourly wind speed.
\tabular{c}{
\figure{F157}{options: width=3.8in}
}
\strong{Example 2}. Daily means of wind speed and ozone.
\tabular{c}{
\figure{F158}{options: width=3.8in}
}
}
\references{
Carslaw, D. & Ropkins, K. (2012) openair - An R package for air quality data analysis. \emph{Environmental Modelling & Software}, 27-28: 52-61. doi \url{10.1016/j.envsoft.2011.09.008}.
Carslaw, D. & Ropkins, K. (2016) Tools for the Analysis of Air Pollution Data. R package version 1.6.7. Available at: \url{https://CRAN.R-project.org/package=openair}.
}
\examples{
\dontrun{

#Example 1

data(Z22)

F69(data=Z22, date="date", var="Ws", YLAB="Wind speed (m/s)")

#Example 2

F69(data=Z22, date="date", var=c("Ws","O3"), avg.time="day")
}
}
\keyword{F69}
