\name{F77}
\alias{F77}
\encoding{latin1}
\title{2D FILLED CONTOUR PLOT}
\description{A 2D filled contour plot is depicted.}
\usage{
F77(data, X, Y, Z, FCONTOUR=NULL,  XLAB=NULL, YLAB=NULL, ZLAB=NULL,
COL=NULL, ResetPAR=TRUE, PAR=NULL,  MTEXT= NULL, TEXT=NULL)
}
\arguments{
  \item{data}{Data file.}
  \item{X}{Variable X.}
  \item{Y}{Variable Y.}
  \item{Z}{Variable Z.}
  \item{FCONTOUR}{It accesses the function \link[graphics]{filled.contour} of base package graphics that allows to modify many different aspects of the 2D plot.}
  \item{XLAB}{Legend of the X axis.}
  \item{YLAB}{Legend of the Y axis.}
  \item{ZLAB}{Legend of the Z axis.}
  \item{COL}{Color palette to be used for the image function or for the contours.}
  \item{ResetPAR}{If it is FALSE, the default condition of the function \link[StatR]{PAR} is not placed and maintained those defined by the user in previous graphics.}
  \item{PAR}{It accesses the function \link[StatR]{PAR} that allows to modify many different aspects of the graph.}
  \item{MTEXT}{It allows to add text on the margins of the graph.}
  \item{TEXT}{It allows to add text in any area of the inner part of the graph.}
}
\value{A 2D filled contour plot is depicted.}  
\details{
\strong{FUNCTIONS}

The plot is performed with the functions \link[graphics]{filled.contour} of base package graphics. The matrix is obtained using the function \link[akima]{interp} of the package
akima (Akima et al., 2015). For further details see Guisande & Vammonde (2012).

\strong{EXAMPLES}

Depth in region of the ocean. 
\tabular{c}{
\figure{F177}{options: width=4in}
}

}
\references{
Akima, H., Gebhardt, A., Petzoldt, T & Maechler, M. (2016) Interpolation of irregularly spaced data. R package version 0.6-2. Available at: \url{https://CRAN.R-project.org/package=akima}.

Guisande, C. & Vaamonde, A. (2012) Grficos estadsticos y mapas con R. Ediciones Daz de Santos, Madrid, 367 pp.
}
\examples{
\dontrun{

#Including the variable Z as a matrix

data(Z10)
m<-as.matrix(Z10[,c(-1,-2)])
F77(data=Z10,  X="Longitude", Y="Latitude",  Z=m)

#Including only a matrix

data(Z10)
m<-as.matrix(Z10[,c(-1,-2)])
F77(data=m)

#With data format not as matrix

data(Z11)
F77(data=Z11,  X="Longitude", Y="Latitude", Z="Depth")}
}
\keyword{F77}
