\name{F87}
\alias{F87}
\encoding{latin1}
\title{SPIDER PLOT}
\description{A spider plot is depicted.}
\usage{
F87(data, var, cat, shade=TRUE, type="p", ResetPAR=TRUE,  PAR=NULL, SPIDER=NULL,
COLOR=NULL, LIMITS=NULL, PCH=NA, LTY=1, AXISP=2, POSL=1.15, MAIN=NULL, LEG=TRUE, 
LEGEND=NULL, MTEXT= NULL, TEXT=NULL)
}
\arguments{
  \item{data}{Data file.}
  \item{var}{Variables.}
  \item{cat}{Variable with the categories.}
  \item{shade}{If it is TRUE the polygons are shaded.}
  \item{type}{It may be radial lines ("r"), a polygon ("p"), symbols ("s") or some combination of these. If lengths is a matrix and \emph{type} is a vector, each row of lengths can be displayed differently.}
  \item{ResetPAR}{If it is FALSE, the default condition of the function \link[StatR]{PAR} is not placed and maintained those defined by the user in previous graphics.}
  \item{PAR}{It accesses the function \link[StatR]{PAR} that allows to modify many different aspects of the graph.}
  \item{SPIDER}{It accesses the function \link[plotrix]{radial.plot} that allows to modify many different aspects of the graph.}
  \item{COLOR}{It allows to modify the colors of the spider plot. It must be as many as different categories of the variable \emph{cat}.}
  \item{LIMITS}{Limits of axes.}
  \item{PCH}{Graphic symbol (see the description of the same argument in the function \link{F1}).}
  \item{LTY}{Type of line (see the description of the same argument in the function \link{F1}).}
  \item{AXISP}{Position of the axis (1, 2, 3 or 4).}
  \item{POSL}{Position of the labels. A highest value means more distant from the plot.}
  \item{MAIN}{Main title of the plot.}
  \item{LEG}{If it is TRUE the legend is shown.}
  \item{LEGEND}{It allows to modify the legend of the plot.}
  \item{MTEXT}{It allows to add text on the margins of the graph.}
  \item{TEXT}{It allows to add text in any area of the inner part of the graph.}
}
\value{It is depicted a spider plot.}  
\details{
\strong{FUNCTIONS}

The plot is performed with the function \link[plotrix]{radial.plot} of the package plotrix (Lemon et al., 2017). 

\strong{EXAMPLE}

The concentration of metals in the sediment of one of the Yahuarkaka lakes (Leticia, Colombia) is used as example. It is selected only three depths.
\tabular{c}{
\figure{F195}{options: width=4in}
}
}
\references{
Lemon, J., Bolker, B., Oom, S., Klein, E., Rowlingson, B., Wickham, H., Tyagi, A., Eterradossi, O., Grothendieck, G., Toews, M., Kane, J., Turner, R., Witthoft, C., Stander, J., Petzoldt, T., Duursma, R., Biancotto, E., Levy, O., Dutang, C., Solymos, P., Engelmann, R., Hecker, M., Steinbeck, F., Borchers, H., Singmann, H., Toal, T. & Ogle, D. (2017) Various plotting functions. R package version 3.7. Available at: \url{https://CRAN.R-project.org/package=plotrix}.
}
\examples{
\dontrun{

data(Z21)
data<-subset(Z21,(Depth==10) |  (Depth==50) |  (Depth==100))
F87(data=data, var=c("Cr","Co","Ni", "Pb", "Al"), cat="Depth")
}
}
\keyword{F87}
